    /*  Program to search given roll number in the list of
	student records,using BINARY SEARCH method.

	Programmer : Mrs. Shivangi G. Potdar.                   */


	#include<stdio.h>
	#define MAX 10   /* Maximum number of students */

	struct rec      /* student Record */
	{
	 int rno;        /* Roll Number */
	 char name[10];  /* Name of student */
	 char cl[15];    /* Class of student */
	 };

	struct rec stud[MAX];

	int bin(int low,int high,int x)
	/* Function for binary search */
	{
	int mid;
	mid=(low+high)/2;
	while(high >= low)
	{
	if (stud[mid].rno==x)  /* Check whether the required name
				  is at 'mid' position in the
				  list */
	{
	  return(mid);   /* if so, send the 'mid' value to main() */
	}
	if (x > stud[mid].rno) /* if roll number is greater than */
	  low=mid+1;           /* roll number at 'mid' then search
				  only in upper half */
	else
	high=mid-1;             /* otherwise search in lower half */

	mid=(int)(low+high)/2;
	}
	 return(-1);  /* Roll number not present */
	}
    /* ----------End of function bin---------------------------------*/
	main()
	{
	 int n,y,loc,i;
	 char ans;
	 clrscr();
	 printf("\n Enter how many students ");
	 scanf("%d",&n);
	 if (n > MAX)
	     printf("\n\t\t Sorry... Array size is less");
	 else
	 {
	   printf("\n\t Enter The Records of %d students :",n);
	   for(i=1;i<=n;i++)
	   {
	     printf("\n Enter the Roll Number , Name and");
	     printf(" Class Of Student %d ",i);
	     printf("\n Roll Number   :");
	     scanf("%d",&stud[i].rno);
	     printf(" Name of Student :");
	     scanf("%s",stud[i].name);
	     printf(" Class           :");
	     scanf("%s",stud[i].cl);
	   }
	   clrscr();
	   do
	   {
	     printf("\n\t Enter the Roll number to be searched : ");
	     scanf("%d",&y);
	     loc=bin(1,n,y);  /* call search function */
	     if (loc !=-1)
	     {
		printf("\n\t\t Target Present in the list :");
		printf("\n Details of the Student :");
		printf("\n Name       : %s",stud[loc].name);
		printf("   Roll Number: %d",stud[loc].rno);
		printf("   Class      : %s",stud[loc].cl);
	     }
	     else
		  printf("\n\t\t Sorry No such Roll Number present");
		  getch();
	    printf("\n\t\t Do you wish to search again");
	    ans=getch();
	   }while((ans=='y' || ans=='Y'));
	 }
	}
/*----------------------End of main-----------------------------------*/