	  /* PROGRAM TO IMPLEMENT BINARY SEARCH TREE.
	     program provides the operations for
		creating,searching,deletion and traversal .

	     Program by: Mrs. Shivangi G. Potdar.         */



	# include <stdio.h>     /* HEADER FILES */
	# include <conio.h>
	# include <dos.h>
	# include <string.h>
	# include <stdlib.h>

	struct node       /* STRUCTURE FOR EACH NODE */
	{
	  char data[15];
	  struct node *left,*right;
	};

	void insert(struct node *,struct node *);
	void tree(struct node *,int);

/*-------------End of Declaration part------------------------------*/

	void main()
	{
	   int choice,c,i,flag;
	   char temp='N',temp1[15];
	   struct node *s,*root,*r,*q;
	   root=NULL;
	   do
	   {
	    clrscr();
	    printf("\n 1.> ENTER     ");
	    printf("\n 2.> DELETE    ");
	    printf("\n 3.> SEARCH    ");
	    printf("\n 4.> DISPLAY ->");
	    printf("\n 5.> EXIT      ");
	    printf("\n\n Enter your choice :");
	    scanf("%d",&choice);
	    switch(choice)
	    {
		  case 1:

			   /* INSERTION OF NODE */
			 printf("****** DATA ENTRY ******\n");
			 do
			 {
			  s=malloc(sizeof(struct node));
			  s->left=NULL;
			  s->right=NULL;
			  printf("\n ENTER DATA : ");
			  scanf("%s",&s->data);
			  if(root==NULL)     /* TREE EMPTY CONDITION */
			    root=s;
			  else
			    insert(root,s);
			  printf("\n ENTER MORE ELEMENTS (Y/N) : ");
			  scanf("\n%c",&temp);
			 }while(temp=='y');
			 break;

		  case 2:

		       /* DELETION OPERATION */
			printf("****** DELETE OPERATION ********\n");
			do
			{
			 printf("\n ENTER ELEMENT TO BE DELETED : ");
			 scanf("%s",temp1);
			 s=root;i=0;flag=0;
			 do
			 {
			   if(strcmp(s->data,temp1)<0)
			   {
				r=s; /* KEEPING TRACK OF PREVIOUS NODE */
				s=s->right;
				i=1;
			   }
			   if(strcmp(s->data,temp1)>0)
			   {
				r=s;
				s=s->left;
				i=2;
			   }
			   if(strcmp(s->data,temp1)==0)
			   {
				flag=1;
				if(i==0)   /* ROOT DELETION CONDITION */
				{
				  if(root->right!=NULL)
				  {
					q=root->left;
					root=root->right;
					insert(root,q);
				  }
				  if(root->right==NULL)
				  {
					root=root->left;
				  }
				}
				else
				{
				if(i==1)
				 /* NODE IS RIGHT TO PREVIOUS NODE*/
				{
					q=s->left;
					r->right=s->right;
					if(s->left!=NULL)
					insert(r,q);
				}
				if(i==2)   /* NODE IS LEFT TO PREVIOUS NODE*/
				{
				  q=s->right;
				  r->left=s->left;
				  if(s->right!=NULL)
					insert(r,q);
				}
			   }
			  }
			 }while(flag==0&&s!=NULL);
			 printf("\n DELETE ANY MORE (y/n) : ");
			 scanf("\n%c",&temp);
			}while(temp=='y');
			break;

		  case 3:

			printf(" ****** SEARCH OPERATION ********\n\n ");
			do
			{
			   printf("\n ENTER NAME TO BE SEARCHED : ");
			   scanf("%s",temp1);
			   i=0;
			   s=root;
			   while(s!=NULL&&i==0)
			   {
			   if(strcmp(s->data,temp1)<0)
			   s=s->right;
			   if(strcmp(s->data,temp1)>0)
			   s=s->left;
			   if(strcmp(s->data,temp1)==0)
			   i=1;
			   }
			 if(i==0)   /* ELEMENT NOT FOUND CONDITION */
			    printf("\n ELEMENT NOT FOUND \n");
			else
			 printf("\n ELEMENT FOUND\n");
			 printf("\n ENTER MORE ELEMENTS (Y/N) : ");
			 scanf("\n%c",&temp);
			}while(temp=='y');
			 break;

		  case 4:
			 clrscr();
			 do
			  {
			     clrscr();
			     printf("\n  1.> PREORDER");
			     printf("\n  2.> INORDER");
			     printf("\n  3.> POSTORDER");
			     printf("\n  4.> NON-RECURSION");
			     printf("\n  5.> EXIT      ");
			     printf("\n Enter your choice :");
			     scanf("%d",&c);

			 if(root==NULL)  /* TREE EMPTY CONDITION */
			   printf("< TREE NOT STARTED YET >");
			 else
			  tree(root,c);
			 printf("\n\n PRESS ANY KEY TO CONTINUE ......");
			 getch();
			}while(c!=5);
			  break;
	    }
	   }while(choice!=5);
	}

/*---------------End of Main function--------------------------------*/

	void insert(struct node *r,struct node *p)
	/* FUNCTION FOR INSERTION */
	{
	  if((r->right==NULL)&&(strcmp(p->data,r->data)>0))
	   /* check whether new node is > root node */
	  {
		r->right=p;
	  }
	  else
	     if((r->right!=NULL)&&(strcmp(p->data,r->data)>0))
	     {
		insert(r->right,p);   /* RECURSIVE CALL*/
	     }

	  if((r->left==NULL)&&(strcmp(p->data,r->data)<0))
	  {
		r->left=p;
	  }
	  else
	   if((r->left!=NULL)&&(strcmp(p->data,r->data)<0))
	   {
		insert(r->left,p); /* RECURSIVE CALL */
	   }
	}
/*--------------------End of function insert------------------------*/

	void tree(struct node *r,int c)
	/* FUNCTION FOR TRAVERSAL */
	{
	  int top,flag;
	  struct node *w,*stack[20];
	  if(r!=NULL)
	  {
		if(c!=4)
		{
		if(c==1)
		  printf("  %s  ",r->data);
		  tree(r->left,c);
		if(c==2)
		  printf("  %s  ",r->data);
		  tree(r->right,c);
		if(c==3)
		  printf("  %s  ",r->data);
		}
	  }
	if(c==4) /* NONRECURSIVE TRAVEL */
	{
	 top=0;
	 w=r;
	 flag=0;
	 while(top!=-1&&w!=NULL)
	 {
	   while(flag==0&&w->left!=NULL)
	   {
		  stack[top]=w;
		  top++;
		  w=w->left;
	   }
	   printf(" %s ",w->data);
	   if(w->right!=NULL)
	   {
		 w=w->right;
		 flag=0;
	   }
	   else
	   {
		top--;
		w=stack[top];
		flag=1;
	   }
	 }
	}
	}

/*------------------End of function tree --------------------*/
