	 /* Program to implement circular queue using linked list
	    Note that the front is the  pointer to point to the
	    start of the queue.

	     Programmar : Mrs. Shivangi. G. Potdar           */

	 #include<stdio.h>
	 #include<stdlib.h>
	 #include<conio.h>

	 struct node
	 {
	  int info;
	  struct node *next;
	 }*p,*q,*front,*rear;

	void add_queue(void);
	void display_queue(void);
	void delete_queue(void);

	void main()
	{
	  char ch,ch1;
	  int y;
	  front=NULL;
	  rear=NULL;
	  do            /*Displaying Menu */
	  {
		clrscr();
		printf("\t------CIRCULAR QUEUE USING LINKED  LIST--------\n");
		gotoxy(9,2);
		printf("1>  ADD AN ELEMENT TO QUEUE\n\n");
		printf("\t2>  DISPLAY QUEUE\n\n");
		printf("\t3>  DELETE AN ELEMENT FROM QUEUE\n\n");
		printf("\t4>  QUIT");
		gotoxy(9,2);
		for(;;)             /* Loop for arrow keys */
		{
			ch = getch();
			if(ch == 13)
				break;
			if(ch == 0)
			{
				ch = getch();
				if(ch == 80)
				{
					y = wherey();
					gotoxy(9,y+2);
				}
				if(ch == 72)
				{
					y = wherey();
					gotoxy(9,y-2);
				}
			}
		}
		switch(wherey())
		{
			case 2 : add_queue();
					 break;
			case 4 : display_queue();
					 break;
			case 6 : delete_queue();
					 break;
			case 8 : exit(1);
					 break;
			default: printf("\nWrong choice!!!!\n");
					 break;
		}
		printf("\nWant to goto main menu ?[y/n]\n");
		flushall();
		ch1 = getch();
	  }while(ch1 == 'y' || ch1 == 'Y');
	}

    /*------------------End of Main Program------------------------*/
	void add_queue(void)
	/* Function to add an element to queue */
	{
	 char ch;
	 clrscr();
	  p = malloc(sizeof(struct node));
	  printf("\n\n\n\tEnter data\n");
	  scanf("%d",&p->info);
	  p->next = NULL;
	  if(front == NULL)   /* If this is the first element */
	  {
	   front= p;
	   rear=p;
	   p->next=front;
	   }
	   else
	   {
	       rear->next=p;
	       rear=rear->next;
	       rear->next=front;
	   }
	}

    /*---------------End of Function add--------------------------*/

	void display_queue(void)       /* Displaying the queue */
	{
	 clrscr();
	 q = front;
	 if(q == NULL)  /*Check for empty condition */
	   printf("\n THE QUEUE IS EMPTY\n");
	 else
	 {
	   printf("\n\t Queue Is :\n ");
	   do
	   {
	     printf("\t%d ",q->info);
	     q = q->next;
	   } while(q!=front);
	  }
	    getch();
	}

    /*------------End of Function Display-------------------------*/
	void delete_queue(void)     /* Deleting number from queue */
	{
	  int num;
	  clrscr();
	  q = front;
	  if(q == NULL)         /* Check for empty condition */
	    printf("\n\n\t\tTHE QUEUE IS EMPTY!!\n");
	  else
	  {
	   printf("\n\t..Element deleted is %d",front->info);
	   front=front->next;
	   q->next=NULL;
	   free(q);
	  }

	}

    /*------------End of Function to Delete----------------------*/
