	  /* PROGRAM TO FIND THE Depth of a binary tree.
	     program first creates the tree and then
	     displays number of leaves .

	     Program by: Mrs. Shivangi G. Potdar.         */



	# include <stdio.h>     /* HEADER FILES */
	# include <conio.h>
	# include <stdlib.h>

	struct node       /* STRUCTURE FOR EACH NODE */
	{
	  int data;
	  struct node *left,*right;
	};
	int k=0;

	void insert(struct node *,struct node *);
	void tree(struct node *,int);

/*-------------End of Declaration part------------------------------*/

	void main()
	{

	   char temp='N';
	   struct node *root,*r,*s;

	   do
	   {
	     root=NULL;
	    clrscr();
			   /* INSERTION OF NODE */
			 printf("****** DATA ENTRY ******\n");
			 do
			 {
			  s=malloc(sizeof(struct node));
			  s->left=NULL;
			  s->right=NULL;
			  printf("\n ENTER DATA : ");
			  scanf("%d",&s->data);
			  if(root==NULL)     /* TREE EMPTY CONDITION */
			    root=s;
			  else
			    insert(root,s);
			  printf("\n ENTER MORE ELEMENTS (Y/N) : ");
			  scanf("\n%c",&temp);
			 }while(temp=='y');

			  clrscr();
			 if(root==NULL)  /* TREE EMPTY CONDITION */
			   printf("< TREE NOT STARTED YET >");
			 else
			  tree(root,1);
			 printf("\t\t Depth of tree is :  %d",k);
			 printf("\n\n PRESS ANY KEY TO CONTINUE ......");
			 getch();
		   printf("\n Try again ?");
		   scanf("\n%c",&temp);
	   }while(temp=='y');
	}

/*---------------End of Main function--------------------------------*/

	void insert(struct node *r,struct node *p)
	/* FUNCTION FOR INSERTION */
	{
	  if(p->data >r->data)
	    {
	     if(r->right!=NULL)
		insert(r->right,p);
	     else
		r->right=p;
	   }
	 else
	  if(p->data<r->data)
	  {
	    if(r->left!=NULL)
	      insert(r->left,p);
	   else
	     r->left=p;
	  }
	   }
/*--------------------End of function insert------------------------*/

	void tree(struct node *r,int level)
	/* FUNCTION FOR TRAVERSAL */
	{
	  if(r!=NULL)
	  {
	   if((r->left ==NULL) &&(r->right==NULL))
	   {
	     if(level>k)
		k=level;
	   }
	  else
	  {
	     tree(r->left,level+1);
	     tree(r->right,level+1);
	  }
	  }
	}
/*------------------End of function tree --------------------*/
