    /*  Program to sort roll numbers in the list of
	student records,using heap sort method.

	Programmer : Mrs. Shivangi G. Potdar.                   */


	#include<stdio.h>
	#define MAX 10   /* Maximum number of students */


	void heapsort(int stud[],int n)
	/* Function for heap sort */
	{
	int i,element,heap_pos,loc,ivalue;
	for(i=1;i<n;i++)          /* create the initial heap */
	{ element=stud[i];
	  heap_pos=i;             /* insert the element in the descendind
				     list in the path formed from the root
				     to leaf i */
	  loc=(heap_pos-1)/2;
	  while(heap_pos>0 && stud[loc]<element)
	  {
	    stud[heap_pos]=stud[loc];
	    heap_pos=loc;
	    loc=(heap_pos-1)/2;
	  }
	  stud[heap_pos]=element;
	}
	for(i=n-1;i>0;i--)       /* place first element in its proper
				    position , adjust the heap */
	{
	ivalue=stud[i];         /* find the larger node from a subtree
				   delete it, and adjust the rest of tree */
	stud[i]=stud[0];
	loc=0;
	if(i==1)
	heap_pos=-1;
	else
	heap_pos=1;
	if(i>2 &&stud[2] > stud[1])
	heap_pos=2;
	while(heap_pos>=0 && ivalue<stud[heap_pos])
	{
	stud[loc]=stud[heap_pos];
	loc=heap_pos;
	heap_pos=2*loc+1;
	if(heap_pos+1<=i-1 && stud[heap_pos]<stud[heap_pos+1])
	heap_pos=heap_pos+1;
	if(heap_pos>i-1)
	heap_pos=-1;
	}
	stud[loc]=ivalue;
	}
	}
    /* ----------End of function heapsort----------------------------*/
	main()
	{
	 int n,i;
	 int stud[MAX];
	 char ans;
	 clrscr();
	 printf("\n Enter how many students ");
	 scanf("%d",&n);
	 if (n > MAX)
	     printf("\n\t\t Sorry... Array size is less");
	 else
	 {
	   printf("\n\t Enter The Records of %d students :",n);
	   for(i=0;i<n;i++)
	   {
	     printf("\n Enter the Roll Number ");
	     scanf("%d",&stud[i]);
	   }
	   clrscr();
	   heapsort(stud,n);
	   do
	   {
	    for(i=0;i<n;i++)
	    printf("\n %d",stud[i]);
	    printf("\n\t\t Do you wish to search again");
	    ans=getch();
	   }while((ans=='y' || ans=='Y'));
	 }
	}
/*----------------------End of main-----------------------------------*/