	 /* PROGRAM FOR CONVERSION OF INFIX EXPRESSION  TO POST FIX
	    EXPRESSION.
	    OPERATOR PRIORITIES ARE ASSUMED AS:

		     + .... 1
		     - .... 2
		     * .... 3
		     / .... 4
		     ^ .... 5
		     ( .... 6
		     ) .... 7.

	   Program by : Mrs. Shivangi G. Potdar.		*/


	# include <stdio.h>    /* HEADER FILES */
	# include <conio.h>
	# include <dos.h>
	# include <string.h>

/*-----------------------End of header file inclusion -------------*/

	int priority(char c)
	 /* FUNCTION TO RETURN PRIORITY */
	{
	 int l=8;
	 if(c=='+')
	   l=1;
	 else if(c=='-')
	   l=2;
	 else if(c=='*')
	   l=3;
	 else if(c=='/')
	   l=4;
	 else if(c=='^')
	   l=5;
	 else if(c=='(')
	   l=6;
	 else if(c==')')
	  l=7;
	 return(l);
	}

/*-------------------End of function priority----------------------*/

	void main()
	{
	  char infix[20],cont,stack[20];
	  int i,j,p;
	  clrscr();
	  printf("\t\t--- INFIX TO POSTFIX CONVERSION ----\n\n");
	  do
	   {
	    printf("\n\t\t ENTER INFIX EXPRESSION : ");
	    scanf("%s",infix);   /* ENTER INFIX EXPRESSION */
	    printf("\n\t\t POSTFIX EXPRESSION     : ");
	    i=0;
	    j=0;

	    do
	    {
	      p=priority(infix[i]);
	      if(p==8)                /* IF CHARACTER IS operand */

		printf("%c",infix[i]);

	      else

		{  /* character is an operator */
		  if(j==0)            /* if it is first operator
					 then PUSH TO STACK */
		   {
		      stack[j]=infix[i];
		      j++;
		   }

		  else /* not a first character */

		  if(p==7)      /* character is  ')'*/
		  {
		     do   /* pop as long as you don't get '(' */
			{
			  printf("%c",stack[j-1]);
			  j--;
			}while(stack[j-1]!='(');
		     j--;
		  }

		  else

		  if(p > priority(stack[j-1])||stack[j-1]=='(')

			{ /* CHECK FOR PRIORITY */
				stack[j]=infix[i];
				j++;
			}

		  else

		   if(p<=priority(stack[j-1]))
		   {
		    while(p<=priority(stack[j-1])&&stack[j-1]!='('&&j!=0)
		    {                  /* POP CONTENTS OF LESS PRIORITY */
			printf("%c",stack[j-1]);
			j--;
		    }

		    stack[j]=infix[i];
		    j++;
		   }

		   else

		   if(p==6)
		    {
			stack[j]='(';
			j++;
		    }

		}
	      i++;
	     }while(i<strlen(infix));

	for(i=j-1;i>=0;i--)
	{
	  if(stack[i]!='(')
	  printf("%c",stack[i]);
	}

	printf("\n\n\t\t CONTINUE (y/n) :");
	scanf("\n%c",&cont);

	}while(cont!='n');    /* CONTINUE CONDITION */
	}

/*-----------------------End of Main-------------------------------*/
