		/* Program to evaluate POSTFIX EVALUATION .

		   Program by : Mrs. Shivangi G. Potdar   */

		   # include<stdio.h>
		   # include<ctype.h>
		   # include<conio.h>
		   # include<string.h>
		   # include<math.h>

		   void push(float , int *, float []);
		   float pop(int *,float []);

/*--------------End of global declarations/definitions---------------*/

	void main(void)
	{
	  char exp[50],str[10],c;
	  int i, j = 0,l, *t = 0, done = 0;
	  float x[4], stack[10];
	  clrscr();
	  strset(exp,'\0');
	  printf("ENTER THE EXPRESSION  ");
	  printf("\n Enter blank between each operand or operator \n\t\t");
	  flushall();
	  gets(exp);
	  l = strlen(exp);
	   strset(str,'\0');        /* INITIALIZE  'str'*/
	 for(i = 0; i<l; i++)
	 {
		 c = exp[i];
		 if( isalpha(c) || iscntrl(c))     /* ERROR CHECK */
		 {
			printf("\n\n\t\tINVALID EXPRESSION !");
			done = 1;
			break;
		 }
		 else
		  if( c != ' ' && isdigit(c))
		     /* IF OPERAND ENCOUNTERED ADD TO 'str' */
		 {
				str[j] = c;
				j++;
		 }
		 else
		    if( c == ' ' && str[0] != '\0')
		   {
			x[0] = atof(str);     /* GET THE OPERAND */
			push(x[0],t,stack);   /* PUSH OPERAND ONTO STACK */
			strset(str,'\0');    /* INITIALIZE 'str'*/
			j = 0;
		 }
		 else
		 if(!(isdigit(c)) && c != ' ')
		     /* IF OPERATOR ENCOUNTERED POP TWICE */
		 {												/* FROM STACK AND PERFORM RELEVANT OPERATION*/
			x[2] = pop(t,stack);
			x[1] = pop(t,stack);
			switch(c)
			{
				case '+' :
					x[3] = x[1] + x[2];
					push(x[3],t,stack);
					break;
				case '-' :
					x[3] = x[1] - x[2];
					push(x[3],t,stack);
					break;
				case '*' :
					x[3] = x[1] * x[2];
					push(x[3],t,stack);
					break;
				case '/' :
					x[3] = x[1] / x[2];
					push(x[3],t,stack);
					break;

				case '^' :
					x[3] = pow(x[1] , x[2]);
					push(x[3],t,stack);
					break;

			}

		 }
	    }
	     x[3] = pop(t,stack);         /* POP ANSWER FROM STACK */
	     if(done == 0)
	     printf("result : %.5f",x[3]);
	     getch();
	}
/*-------------------End of main function---------------------------*/

	void push(float s, int *t, float st[])
	/* function to PUSH element onto stack s */
	{
	 *t = *t+1;
	 st[*t] = s;
	}
/*--------------End of function push-------------------------------*/

	float pop(int *t,float st[])
	/* Function to pop the elements from stack */
	{
	 float s;
	 s = st[*t];
	 *t = *t-1;
	return(s);

	}
/*------------end of function pop---------------------------------*/
