	/* Program to convert prefix expression to postfix .
	   Program by :Mrs. Shivangi G. Potdar              */

	#include <stdio.h>
	#include <conio.h>
	#include <stdlib.h>
	#include <alloc.h>
	#include <string.h>
	#include <ctype.h>

	/* Defining Function Prototypes */
	/* ---------------------------- */

	void disp(char *s);
	int check(char *s);
	struct list *convert(struct list *p);
	void print(struct list *p);

	struct list
	{
	 char data;
	 struct list *next;
	}*first;


/*-----------------------------------------------------------------*/

	void main(void)
	{
	 char s[35],ch;
	 int flag;
	 do
	 {
		clrscr();
		printf("\n\tEnter The Prefix Expression:\n\n\t");
		gets(s);
		flag=check(s);
		if(!flag)
			printf("\n\tError In Entering The Expression\a");
		else
			disp(s);

		printf("\n\tDo You Want To Continue(Y/N)?");

		do
			ch=getch();
		while(ch!='n' && ch!='N' && ch!='y' && ch!='Y');

	}while(ch!='n' && ch!='N');
	return;
	}
/*-------------------End of main function--------------------------*/

	/* Function Prints The Equivalent Infix Expression */
	/* ----------------------------------------------- */

	void disp(char *s)
	{
	 struct list *node,*last;

	 last=first=NULL;
	 while((*s)!='\0')
	 {
	   node=(struct list *)malloc(sizeof(struct list));
	   node->data=(*s);
	   node->next=NULL;
	   if(first==NULL)
		first=last=node;
	   else
		{
			last->next=node;
			last=last->next;
		}
	   s++;
	}
	first=convert(first);
	printf("\n\tPost fix form is :");
	print(first);
	return;
	}
/*----------------end of disp function------------------------------*/

	struct list *convert(struct list *p)
	{
	 int opr_count=0;
	 char s;
	 struct list *temp,*q,*r;

	if(p->next==NULL)
		return(p);

	temp=p->next;
	s=temp->data;

	while(temp && (s=='*' || s=='-' || s=='+' || s=='/' || s=='^'))
	{
		opr_count++;
		temp=temp->next;
		s=temp->data;
	}
	while(opr_count!=0)
	{
		temp=temp->next;
		opr_count--;
	}

	q=temp->next;
	temp->next=NULL;
	temp=p->next;
	p->next=NULL;

	q=convert(q);
	temp=convert(temp);
	r=temp;
	while(temp->next!=NULL)
		temp=temp->next;
	temp->next=q;
	while(q->next!=NULL)
		q=q->next;
	q->next=p;
	return(r);
	}
/*----------------------End of function convert--------------------*/


	/* Function Check Will Trace An Error If Any */
	/* ----------------------------------------- */

	int check(char *s)
	{
	 int var_count=0,opr_count=0;

	 if(!(*s=='*' || *s=='-' || *s=='+' || *s=='/' || *s=='^'))
		return(0);

	while((*s) != '\0')
	{
		if(*s=='*' || *s=='-' || *s=='+' || *s=='/' || *s=='^')
			opr_count++;
		else if(isalpha(*s))
			var_count++;
		else
			return(0);
		s++;
	}
	s--;
	if(!isalpha(*s))
		return(0);
	return( (var_count-opr_count)==1?1:0 );
	}
/*------------------------End of function check---------------------*/

	void print(struct list *p)
	/* function to display postfix form */
	{
	while(p)
	{
		printf("%c",p->data);
		p=p->next;
	}
	return;
	}
/*--------------------End of function print----------------------*/
