
    { Program to implement singly linked list.}

    PROGRAM LINK_LST;
    TYPE
       PTR =^NODE;      {define the node structure.}
       NODE=RECORD
          INFO :INTEGER;
          NEXT :PTR;
          END;

    VAR
       BASE     :PTR;  {pointer to point to the beginning of the list}
       X,ANS    :INTEGER;

{---------------end of declaration-------------------------------------------}
    PROCEDURE ADD(X:INTEGER);
    {Procedure to add an element to the list }

     VAR P,Q:PTR;
     BEGIN
         NEW(P);
         P^.INFO:=X;
         P^.NEXT:=NIL;
         IF(BASE = NIL) THEN
            BASE :=P
         ELSE
         BEGIN
             Q :=BASE;
             WHILE (Q^.NEXT <> NIL) DO
                   Q:=Q^.NEXT;
             Q^.NEXT :=P;
         END;
    END;
{----------------------end of procedure ADD---------------------------------}

    PROCEDURE DELETE_LL(X:INTEGER);
    {Procedure to delete an element from the list}
    VAR
      Q,R   :PTR;
      FOUND :BOOLEAN;
    BEGIN
        FOUND:=FALSE;
        Q:=BASE;
        IF (Q=NIL) THEN
           WRITELN('':10,'LIST IS EMPTY')
        ELSE
        BEGIN
            WHILE (NOT(FOUND)) AND(Q<>NIL) DO
            BEGIN
                IF (Q^.INFO=X) THEN
                   FOUND:=TRUE
                ELSE
                   Q:=Q^.NEXT
             END;
        IF (FOUND) THEN
        BEGIN
           WRITELN('':10,X:2,'  IS FOUND');
           R:=BASE;
           IF (R=Q) THEN
            Begin
                base:=base^.next;
                r^.next:=nil;
                dispose(r);
            end
           else
            begin
            WHILE (R^.NEXT <> Q) DO
            R:=R^.NEXT;
            R^.NEXT :=Q^.NEXT;
            Q^.NEXT:=NIL;
            DISPOSE(Q);
            end;
        END
        ELSE
           WRITELN('':10,X:2,'IS NOT PRESENT IN THE LIST');
       END;
    END;

{--------------------end of procedure delete--------------------------}

    PROCEDURE DISPLAY;
    {Procedure to print the elements of the list}
    VAR
      Q:PTR;
    BEGIN
        IF (BASE=NIL) THEN
            WRITELN('':10,'LIST IS EMPTY')
        ELSE
        BEGIN
             Q:=BASE;
             WHILE (Q <> NIL) DO
             BEGIN
                 WRITELN(Q^.INFO);
                 Q:=Q^.NEXT;
             END;
        END;
    END;

{---------------------end of DISPLAY procedure--------------------------}

    BEGIN {main}
        clrscr;
        BASE:=NIL;
        ANS:=1;
        WHILE(ANS <> 4) DO
        BEGIN
            WRITELN('':10,'1. ADD');
            WRITELN('':10,'2. DELETE');
            WRITELN('':10,'3. PRINT');
            WRITELN('':10,'4. EXIT');
            WRITELN;WRITELN;
            WRITE('':10,'ENTER OPTION');
            READLN(ANS);
            CASE ANS OF
                     1:Begin
                         WRITE('':10,'ENTER NUMBER TO ADD  ');
                         READLN(X);
                         ADD(X);
                        End;

                     2: Begin
                           WRITE('ENTER NUMBER TO BE DELETED ');
                           READLN(X);
                           DELETE_LL(X);
                        End;

                     3:DISPLAY;
            END;
        END;
    END.

{---------------------end of main-------------------------------------}

