{PROGRAM TO CONVERT POSTFIX EXPRESSION TO INFIX EXPRESSION}

    PROGRAM POST_IN;
    TYPE
        ISLE = STRING[50];  {maximum size of the postfix expression}
    VAR
      TYP,STR1,STR2,DATA,ITEM,INFIX:ISLE;
      W,CHOICE                     :CHAR;
      OPSET                        :SET OF CHAR;
      STACK                        :ARRAY [1..20] OF ISLE;
      INDEX,I                      :INTEGER;
      ANS                          :CHAR;

{-------------end of declarations-----------------------------------}

    PROCEDURE PUSH(TOKEN:ISLE);
    {Procedure to push the operand or partial infix token}
    BEGIN
        INDEX:=INDEX+1;
        STACK[INDEX]:=TOKEN;
    END;

{-------------end of PUSH -----------------------------------------}

    PROCEDURE CONVERT;

    {procedure to convert the postfix expression to its equivalent
      infix form}
    BEGIN
        I    :=1;
        INDEX:=0;
        REPEAT
            ITEM:=DATA[I];
            W:=ITEM;
            IF W IN OPSET THEN
               TYP:='RANK 2'
            ELSE
            IF COPY(DATA,I,2)=':=' THEN
            BEGIN
               TYP:='RANK 2';
               ITEM:=COPY(DATA,I,2);
               I:=I+1;
            END
            ELSE
              IF COPY(DATA,I,3)='MOD' THEN
              BEGIN
                TYP:='RANK 2';
                ITEM:=COPY(DATA,I,3);
                I:=I+2;
              END
              ELSE
              IF COPY(DATA,I,3)='DIV' THEN
              BEGIN
                  TYP:='RANK 2';
                  ITEM:=COPY(DATA,I,3);
                  I:=I+2;
              END
              ELSE
              IF COPY(DATA,I,3)='AND' THEN
              BEGIN
                 TYP:='RANK 2';
                 ITEM:=COPY(DATA,I,3);
                 I:=I+2;
               END
              ELSE
              IF COPY(DATA,I,3)='NOT' THEN
              BEGIN
                  TYP:='RANK 1';
                  ITEM:=COPY(DATA,I,3);
                  I:=I+2;
              END
              ELSE
              IF COPY(DATA,I,2)='OR' THEN
              BEGIN
                  TYP:='RANK 2';
                  ITEM:=COPY(DATA,I,2);
                  I:=I+1;
              END
              ELSE
              IF COPY(DATA,I,2)='<>' THEN
              BEGIN
                  TYP:='RANK 2';
                  ITEM:=COPY(DATA,I,2);
                  I:=I+1;
               END
               ELSE
               IF COPY(DATA,I,2)='<=' THEN
               BEGIN
                  TYP:='RANK 2';
                  ITEM:=COPY(DATA,I,2);
                  I:=I+1;
               END
               ELSE
               IF COPY(DATA,I,2)='>=' THEN
               BEGIN
                   TYP:='RANK 2';
                   ITEM:=COPY(DATA,I,2);
                   I:=I+1;
               END
               ELSE
                IF COPY(DATA,I,1)='~' THEN
                BEGIN
                  TYP:='RANK 1';
                END
                ELSE
                  TYP:='OPERAND';
             IF TYP='OPERAND' THEN
                 PUSH(ITEM);
             IF TYP='RANK 1' THEN
             BEGIN
                STR1:=STACK[INDEX];
                INDEX:=INDEX-1;
                ITEM:='('+ITEM+STR1+')';
                PUSH(ITEM);
             END;
                IF TYP='RANK 2' THEN
                BEGIN
                  STR1:=STACK[INDEX];
                  INDEX:=INDEX-1;
                  STR2:=STACK[INDEX];
                  ITEM:='('+STR2+ITEM+STR1+')';
                  INDEX:=INDEX-1;
                  PUSH(ITEM);
                END;
                I:=I+1;
        UNTIL (I>LENGTH(DATA));

        ITEM:=STACK[INDEX];
        INDEX:=INDEX-1;
        INFIX:=COPY(ITEM,2,LENGTH(ITEM)-2);
       WRITELN(' ':5,'INFIX EXPRESSION IS :',INFIX);
    END;

{------------------end of procedure convert--------------------------}

    BEGIN
        OPSET :=['^','+','-','*','/','=']; {define the operator set}
     REPEAT
        CLRSCR;
        WRITE('':5,'ENTER POSTFIX EXPRESSION');
        READLN(DATA);
        CONVERT;
        WRITE('':10,'DO YOU WISH TRY ANY MORE ?(Y/N) ');
        READLN(ANS);
     UNTIL(ANS='N');
    END.

{---------------end of main program---------------------------------}