       { shortest path between a pair of
        nodes in weighted graph,using Dijkstra's algo.

         Program :SHORTEST PATH.               */}

         PROGRAM SHORTEST;

         const  member=1; {/* used to indicate current node
                              which has become working node */}

                nonmember=0; { /* indicates node not prcessed */}

                infinity=999;  {/* initial distance */}

         TYPE
              ARC = RECORD  {define node structure to store adj.list}
                     wt:INTEGER;
                    END;

              ARR1=ARRAY[0..10,0..10] OF ARC ;
              arr2=ARRAY[0..10] OF INTEGER;

         VAR
            g     :ARR1; {/* struct to hold the graph */}
            path  :arr2;
            c     :ARR1;
            n,s,t :INTEGER;
            preced:arr2;
            x     :INTEGER;
{/*--------------End of global definitions--------------------*/}

         PROCEDURE joinwt(VAR g:ARR1;node1,node2,wt:INTEGER);
         {/* function to assign the weights on arcs */}
         BEGIN
            g[node1,node2].wt:=wt; {/* assign the weight to arc node1-node2*/}
         END;

{/*-------------end of function joinwt---------------------------------*/}

         PROCEDURE cost (var c:ARR1;n:INTEGER);
         {/* function to get the weights */}
         VAR
            i,j,wt:integer;
            BEGIN
              for i:=0 TO N-1 DO
               for j:=0 TO N-1 DO
               begin
                  WRITELN(' weight of arc',i,j);
                  READLN(wt);
                     joinwt(c,i,j,wt);
               end;
               WRITELN;
            END;

{/*-------------------End of procedure cost----------------------------*/}

         PROCEDURE mat(a:arr1;n:integer);
         {/* function to print the weight matrix */}

          VAR
              i,j:integer;
          begin
  WRITELN;
  for i:=0 to n-1 do
  begin
   for j:=0 to n-1 do
   begin
    WRITE('   ',a[i,j].wt);
   end;
    WRITELN;
 end;
end;
{/*-------------------End of function mat--------------------------*/}
PROCEDURE shortpath(wt:ARR1;s,t,n:INTEGER;preced:arr2;var x:integer);
VAR
   dist,perm:ARRAY[0..10] OF INTEGER;
   dc,mm,k,h,curr,i,j,smalldist,newdist:INTEGER;
    path:ARRAY [0..10] OF INTEGER;
 BEGIN
    h:=0;
  for i:=0 TO N-1 DO {/* initialise */}
  BEGIN
   perm[i]:=nonmember;{  /* no node is prcessed */}
   dist[i]:=infinity; { /* initial distance is infinity */}
  END;
  perm[s]:=member; {/* start from 's' */}
  dist[s]:=0;
  curr:=s; {/* working node is curr */}
  while(curr <> t) DO {/* till we are not at destination */}
   BEGIN
    smalldist:=infinity;
    dc:=dist[curr];
    for i:=0 TO N-1 DO
    if(perm[i]=nonmember) then {/* find smallest distance from current
                                working node */}
    BEGIN
     newdist:=dc+wt[curr,i].wt;
     if(newdist<dist[i]) THEN
     BEGIN
       dist[i]:=newdist;
       preced[i]:=curr;
     END;
    if(dist[i]<smalldist) THEN
    BEGIN
      smalldist:=dist[i];
      k:=i;
    END;
   END;
   curr:=k;
   perm[curr]:=member;
   path[h]:=curr;
    h:=h+1;
 END;
 x:=dist[t];
END;
{/*-----------------End of function shortpath---------------------*/}

BEGIN
  clrscr;
  WRITELN(' How many nodes :');
  READLN(n);
  WRITELN(' Enter the adjacency matrix of weight ');
  WRITELN(' Enter 999 if no edge exists :');
  cost(c,n);
  clrscr;
  WRITELN(' weight matrix :');
  mat(c,n);
  WRITELN(' ENTER SOURCE AND DESTINATION ');
  READLN(s,t);
  WRITELN('Shortest PATH BETWEEN',s,' AND ',t,' IS:');
  shortpath(c,s-1,t-1,n,preced,x);
  WRITELN(' The path length is ',x);
end.
{/*---------------------End of main----------------------------------*/}

