	/*        GRAPH TRAVERSAL USING BFS.

	  The program includes a header file bfs.h, which defines
	  the actual algorithm.
	  The program is menu driven, use arrow keys for selecting
	  the choices.
	  In this program we have just created a menu and called
	  bfs routine.

	   Program by : Mrs. Shivangi G. Potdar. */


	#include<stdio.h>
	#include<conio.h>
	#include<ctype.h>
	#include"d:\tc\bfs.h"

	void main(void)
	{
	  char x;
	  char menu[2][30];
	  int choice = 1, y;
	  strcpy(menu[0],"1 :   BFS TRAVERSAL");  /*Store Choices in menu*/
	  strcpy(menu[1],"2 :   EXIT");
	  window(15,7,45,13);
	  clrscr();
	  do
	  {
	   clrscr();
	   gotoxy(1,2);
	   cprintf("%s",menu[1]);
				 /* The choice of user is*/
				/*highlighted on the screen*/
	  textbackground(15);
	  textcolor(0);
	  gotoxy(1,1);
	  cprintf("%s",menu[0]);
	  x = getch();
	  while(x != 13)   /*13 is the ascii value of the enter key*/
	  {
		textbackground(0);
		textcolor(15);
		gotoxy(1,1);
		cprintf("%s",menu[0]);
		gotoxy(1,2);
		cprintf("%s", menu[1]);
		if(x == 80)   /*If key pressed is down arrow */
		{
			if(choice < 2)
				choice++;
			else
				choice = 1;
		}
		if(x == 72)  /*If the key pressed is up arrow key*/
		{
			if(choice > 1)
				choice--;
			else
				choice = 2;
		}
		gotoxy(1, choice);
		textbackground(15);
		textcolor(0);
		cprintf("%s",menu[choice-1]);
		flushall();
		gotoxy(1,7);
		printf("YOUR CHOICE IS : ");
		cprintf("%d",choice);
		x = getch();
	  }
		  textcolor(15);
		  window(1,1,80,24);
		  textbackground(0);
		  switch(choice)
		   {
		     case 1	:
				  bfs();  /* call the bfs function */
				  break;
		     case 2     :
				  clrscr();
				  printf("\nPRESS ANY KEY TO EXIT.....");
				  getch();
		  }
	  }while(choice != 2);
	}

/*------------------End of Main----------------------------------------*/
