		/*TRAVERSAL OF A GRAPH BY BFS*/

	#include<stdio.h>
	#include<conio.h>
	#include<ctype.h>
	#include<stdlib.h>

	int mat(int adj[10][10]);
	void bfs2(int adj[10][10],int no);
	void push(int j);
	int pop(void);
	void search1(int adj[10][10],int j,int no);

	struct node
	{
	   int info;
	   struct node *next;
	};

	struct node *p1,*front1,*rear1;

	int v1[10];
/*---------------------End of declaration part------------------------*/

	void bfs()
	{
	  int adj[10][10],no,i,j;
	  char answer;
	  do
	  {
		clrscr();
		printf("\t***BFS TRAVERSAL***");
		front1 = NULL;
		rear1 = NULL;
		for(i=0;i<10;i++)
		 /*Visited array is set to indicate that no node is visited */
		 v1[i] = 0;
		for(i=0;i<10;i++)
		{
		for(j=0;j<10;j++)
		  /*Adjacentcy matrix is initialized to 0*/
		adj[i][j] = 0;
		}
		no = mat(adj);
		bfs2(adj,no);
		do
		{
		printf("\n\nDO YOU WISH TO CONTINUE ?");
		fflush(stdin);
		scanf("%c",&answer);
		answer = tolower(answer);
		}while(answer != 'y' && answer != 'n');
	  }while(answer != 'n');
	}

/*------------------End of bfs function-----------------------------*/

	/*Function to create the adjacentcy matrix*/

	int mat(int adj[10][10])
	{
	  int no,i,j;
	  printf("\nENTER THE NO OF NODES IN GRAPH : ");
	  scanf("%d",&no);
	  if(no <= 1) /* number of nodes less than or equal 1*/
	  {
	    do
	    {
	      fflush(stdin);
	      gotoxy(34,2);
	      printf(" ");
	      gotoxy(34,2);
	      scanf("%d",&no);
	    }while(no <= 1);
	  }
	printf("\n\t\tCREATE THE ADJACENTCY MATRIX\n");
	gotoxy(20,5);
	for(i=0;i<no;i++)
	printf("NODE%d  ",i+1);
	gotoxy(10,7);
	for(i=0;i<no;i++)
	printf("\n\tNODE%d\n",i+1);
	for(i=0;i<no;i++)
	{
	for(j=0;j<no;j++)
	{
	 gotoxy((20+(8*j)),(8+(2*i)));/*Indicate that no node is connected*/
		if(i==j)              /*to itself*/
		  printf("0");  /* no loop back to same node */
		else
		{
		  adj[i][j] = 2;
		  fflush(stdin);
		  scanf("%d",&adj[i][j]);  /*Enter only 1 or 0*/
		  while(adj[i][j] != 0 && adj[i][j] != 1)
		  {
			gotoxy((20+(8*j)),(8+(2*i)));
			printf("        ");
			gotoxy((20+(8*j)),(8+(2*i)));
			fflush(stdin);
			scanf("%d",&adj[i][j]);
		  }
		}
	}
	}
	return(no);
	}
/*------------------End of function mat------------------------------*/

	void bfs2(int adj[10][10],int no)
	/* Function to traverse the graph using BFS algorithm. */
	{
	  int i,j,flag=0;
	  printf("\nORDER OF TRAVERSAL IS : \n");
	  i=0;
	  while(flag != 1)
	  {                /*Find a node in adjacentcy matrix which is */
	    for(j=0;j<no;j++)     /*connected to some other node*/
	    {
	     if(adj[i][j] == 1)
	     flag = 1;
	    }
	    i++;
	  }
	  if(i <= no)
	  {
	    push(i-1);

	    while(rear1 != NULL && front1 != NULL)
	    {
		j = pop();
		printf("NODE%d ",j+1);
		search1(adj,j,no);
	    }
	    flag = -1;
	    for(j = 0;j<no;j++)
	    {
		if(v1[j] != 1)
		flag = j;
	    }
	    if(flag != -1)
	    printf("\nTHE GRAPH IS NOT CONNECTED");
	    getch();
	  }
	  else
	    printf("\nTHE GRAPH IS NOT CONNECTED");
	}

/*----------------------End of BFS function -----------------------*/

/*Pushing the current node as it's row in matrix must be checked later*/
	void push(int j)
	{
	  v1[j] = 1;    /*Mark the node as visited in the visited array*/
	  p1 = malloc(sizeof(struct node));
	  p1->info = j;
	  p1->next = NULL;
	  if(front1== rear1 && rear1== NULL)
	  {
	    rear1 = p1;
	    front1 = p1;
	  }
	  else
	  {
	    rear1->next=p1;
	    rear1 = rear1->next;
	  }
	}
/*-----------------End of PUSH function------------------------------*/
	/*Pop the next working node*/
	int pop()
	{
		int x;
		if(front1 != rear1)
		{
		  p1 = front1;
		  x = p1->info;
		  front1 = front1->next;
		  p1->next = NULL;
		  free(p1);
		}
		else
		{
		 p1=front1;
		 x = p1->info;
		 free(p1);
		 front1 = NULL;
		 rear1 = NULL;
		}
	 return(x);

	}
/*-------------End of function POP----------------------------------*/

	void search1(int adj[10][10],int i,int no)
	/* Find the adjacent nodes */
	{
	  int j;   /*searching the adjacentcy matrix for a node*/
	  for(j = 0;j<no;j++)  /*connected to the currently working node*/
	  {
	   if(adj[i][j] == 1 && v1[j] != 1)
	   {
		v1[j] = 1;
		push(j);
	   }
	  }
	}
/*-------------------End of function search-----------------------*/
