	 /*Program to implement CIRCULAR linked list.
	   To use the menu options use arrow keys.
	   Programmer : Mrs. Shivangi G. Potdar*/

	 #include<stdio.h>
	 #include<stdlib.h>
	 #include<conio.h>

	struct node
	{
	 int info;
	 struct node *next;
	}*start, *p, *q, *r;

	void create_list(void);
	void display_list(void);
	void delete_elmnt(void);

	void main()
	{
	 char ch,ch1;
	 int y;
	 start=NULL;
	 do            /*Displaying Menu */
	 {
	  clrscr();
	  printf("--------------LINKED  LIST-----------------\n");
	  gotoxy(9,2);
	  printf("1>  ADD TO A LIST\n\n");
	  printf("\t2>  DISPLAY LIST\n\n");
	  printf("\t3>  DELETE ELEMENT\n\n");
	  printf("\t4>  QUIT");
	  gotoxy(9,2);
	  for(;;)             /* Loop for arrow keys */
	  {
		ch = getch();
		if(ch == 13)
		  break;
		if(ch == 0)
		 {
		  ch = getch();
		  if(ch == 80)
		  {
		   y = wherey();
		   gotoxy(9,y+2);
		  }
		  if(ch == 72)
		  {
		   y = wherey();
		   gotoxy(9,y-2);
		  }
	     }
	  }
	  switch(wherey())
	  {
		case 2 : create_list();
			 break;
		case 4 : display_list();
			 break;
		case 6 : delete_elmnt();
			 break;
		case 8 : exit(1);
			 break;
		default: printf("\nWrong choice!!!!\n");
			 break;
	  }
	  printf("\nDo you want to continue?[y/n]\n");
	  flushall();
	  ch1 = getch();
	 }while(ch1 == 'y' || ch1 == 'Y');
	}
    /*------------End of Main-----------------------------------*/

	void create_list(void)          /* Creating the list */
	{
	 char ch;
	 clrscr();
		p = malloc(sizeof(struct node));
		printf("\n\n\n\tEnter data\n");
		scanf("%d",&p->info);
		p->next = NULL;
		if(start == NULL)
			{start = p;
			p->next=start;
			}
		else              /* find last node in list */
		{
		 q=start;
		 while (q->next != start)
		     q=q->next;
		 q->next=p;
		 p->next=start;
		}
	}
    /*----------End of function to create list------------------*/

	void display_list(void)       /* Displaying the list */
	{
	 clrscr();
	 q = start;
	 if(q == NULL)  /*Check for empty condition */
	  printf("\n THE LIST IS EMPTY\n");
	 else
	 {
	  printf("\n\n\n");
	  do
	  {
	   printf("%d\t",q->info);
	   q = q->next;
	  }while(q != start);
	 }
	 getch();
	}
    /*-----------End of Display function-------------------------*/

	void delete_elmnt(void)   /* Deleting number from list */
	{
	 int num,found=0;
	clrscr();
	q = start;
	if(q == NULL)         /* Check for empty condition */
	   printf("\n\nTHE LIST IS EMPTY!!\n");
	else
	{
	   printf("Enter the number to be deleted ");
	   scanf("%d",&num);
	   while((found==0) && (q!=NULL))
	   { if(q->info == num)
	       found=1;
	     else
	      q=q->next;
	   }
	   if (found==0)
	   {
	      printf("\n No Such Number is in List");
	      getch();
	   }
	   else
	   {
	   if (q==start) /* If it is a first node */
	       { start=start->next;
		 q->next=NULL;
		 free(q);
	       }
	  else
	  {
	   r=start;   /* Find the previous node of q*/
	   while(r->next !=q)
		r=r->next;
	   r->next=q->next;
	   q->next=NULL;
	   free(q);
	  }
	  }
	 }
       }
    /*------------End of Function Delete------------------------*/