	/*Program to implement circular queue using arrays
	  This program uses kounter method, to keep track of
	  the number of elements.
	  Programmar : Mrs. Shivangi G. Potadr             */

	#include<stdio.h>

	# define MAXSIZE 3
	/* Define the maximum number of elments that
	   you would like to place in the queue */

	struct st{
		 int front,rear;
		 int kount;
		 int queue[MAXSIZE];
		 };

	struct  st s;  /* A working variable s */
	/*---------------------------------------------------------*/

       /* Define the function prototypes, the basic operations
	  that can be performed on the queue */

		int empty(void);
		int full(void);
		void add(void);
		void delete(void);
		void display(void);


	void main()
	{
	   char ans;
	   int ch;
	   s.front=0;
	   s.rear=-1;
	   s.kount=0;
	   do
	   {
	    clrscr();
	    printf("\t\t\tCIRCULAR QUEUE program\n");   /*Displaying Menu */
	    printf("\n\t\t 1> ADD\n");
	    printf("\n\t\t 2> DELETE\n");
	    printf("\n\t\t 3> DISPLAY\n");
	    printf("\n\t\t 4> QUIT\n");
	    printf("\n\t.......Enter your choice  ");
	    scanf("%d",&ch);
	    switch(ch)
		{
		  case 1 :
			  add();
			  break;
		  case 2 :
			  delete();
			  break;
		  case 3 :
			  display();
			  break;
		  case 4 :
			  exit(1);
			  break;

		  default: printf("Wrong choice!!!!\n");
					 break;
		}
		printf("\n\t\tWnat to go to main menu ?[y/n] ");
		flushall();
		ans = getch();
	   }while(ans == 'y' || ans == 'Y');
	    printf("\nPRESS ANY KEY TO EXIT ...\n");
	    getch();
	}
 /* -----------END OF MAIN FUNCTION--------------------------------*/
	int full(void)
	/* Function to check whether the queue is full or not.
	   It returns a value 1 if true otherwise returns 0. */

	{
	  if (s.kount == MAXSIZE)
	     return(1);
	  else
	     return(0);
	}

 /* -----------END OF FUNCTION full--------------------------------*/


	int empty(void)
	/* Function to check whether the queue is empty or not.
	   It returns a value 1 if true otherwise returns 0. */

	{
	if (s.kount == 0)
	   return(1);
	else
	   return(0);
	}

 /* -----------END OF FUNCTION empty--------------------------------*/

	void add(void)
	/* Function to add an element onto a queue */
	{
	char ch;
	int x;
	do
	{
	   if(full()==1)   /* Check for queue full condition */
	   {
		printf("\n\n\t\tQueue Full !!!\n");
		break;
	   }
	   else
	   {
	      s.rear = (s.rear + 1) % MAXSIZE;
	      printf("\nEnter an element to be added ");
	      scanf("%d",&x);
	      s.queue[s.rear] = x;
	      s.kount++;
	    }
	    printf("\n\tDo you want to add more elements? [y/n]");
	    flushall();
	    ch = getch();
	}while(ch == 'y' || ch == 'Y');
	}
 /* -----------END OF FUNCTION add--------------------------------*/

	void delete(void)
	/* Function to delete an element off a queue */
	{
	 char ch;
	 do
	 {
	   if(empty()== 1)     /* check for queue empty */
	   {
		printf("\n\n\t\tQueue Empty!!\n");
		break;
	   }
	   else
	   {
	    printf("\t\t%d has been deleted!",s.queue[s.front]);
	    s.front =(s.front+1) % MAXSIZE;
	    s.kount--;
	   }
	  printf("\n\t\tDo you want to delete more ? [y/n] ");
	  flushall();
	  ch = getch();
	}while(ch == 'y' || ch == 'Y');
	}
 /* -----------END OF FUNCTION delete--------------------------------*/
	void display(void)
	/* Function to display queue elements */
	{
	 int i;
	 clrscr();
	 if(empty()== 1)
		printf("\n\n\t\tQUEUE  Empty!!!!");
	  else
	  {
	    printf("\n\n\t\tDisplaying queue....\n");
	    for(i = s.front; i <= s.rear; i++)

		printf("\n\t\t%d",s.queue[i]);

	  }
	}
 /* -----------END OF FUNCTION display--------------------------------*/
