		/*TRAVERSAL OF A GRAPH By DFS*/

	#include<stdio.h>
	#include<conio.h>
	#include<ctype.h>
	#include<stdlib.h>

	int mat(int adj[10][10]);
	void dfs(int adj[10][10],int no);
	void push(int j);
	int pop(void);
	void search(int adj[10][10],int j,int no);


	struct node
	{
	 int num;
	 struct node *next;
	};
	struct node *p,*front,*rear;

	int v[10];
/*-------------------------End of declaration part----------------*/

	void dfs1()
	{
	  int adj[10][10],no,i,j;
	  char resp;
	  do
	  {
	    clrscr();
	    printf("\t***DFS TRAVERSAL***");
	    front = NULL;
	    rear = NULL;
	   for(i=0;i<10;i++)
	     /*Visited array is set to indicate that no node is */
	   v[i] = 0;      /*visited*/
	  for(i=0;i<10;i++)
	  {
	   for(j=0;j<10;j++)     /*Adjacentcy matrix is initialized to 0*/
		adj[i][j] = 0;
	  }
		no = mat(adj);
		dfs(adj,no);
		do
		{
		printf("\n\nDO YOU WISH TO CONTINUE ?");
		fflush(stdin);
		scanf("%c",&resp);
		resp = tolower(resp);
		}while(resp != 'y' && resp != 'n');
	  }while(resp != 'n');
	}
/*--------------End of function dfs-----------------------------*/

	/*Function to create the adjacentcy matrix*/
	int mat(int adj[10][10])
	{
	  int no,i,j;
	  printf("\nENTER THE NO OF NODES IN GRAPH : ");
	  scanf("%d",&no);
	  if(no <= 1)
	  {
	   do
	    {
	     fflush(stdin);
	     gotoxy(34,2);
	     printf(" ");
	     gotoxy(34,2);
	     scanf("%d",&no);
	    }while(no <= 1);
	  }
	  printf("\n\t\tCREATE THE ADJACENTCY MATRIX\n");
	  gotoxy(20,5);
	  for(i=0;i<no;i++)
	  printf("NODE%d  ",i+1);
	  gotoxy(10,7);
	  for(i=0;i<no;i++)
	  printf("\n\tNODE%d\n",i+1);
	  for(i=0;i<no;i++)
	  {
	   for(j=0;j<no;j++)
	   {
	    gotoxy((20+(8*j)),(8+(2*i)));
	    if(i==j)
		printf("0");       /*Indicate that no node is connected*/
	    else                   /*to itself*/
	    {
		adj[i][j] = 2;
		fflush(stdin);           /*Error check -- only 1 or 0*/
		scanf("%d",&adj[i][j]);  /*can be entered by user*/
		while(adj[i][j] != 0 && adj[i][j] != 1)
		{
		  gotoxy((20+(8*j)),(8+(2*i)));
		  printf("        ");
		  gotoxy((20+(8*j)),(8+(2*i)));
		  fflush(stdin);
		  scanf("%d",&adj[i][j]);
		}
	    }
	   }
	 }
		return(no);
	}
/*---------------End of function mat-------------------------------*/

	void dfs(int adj[10][10],int no)

	/* Function to implement dfs algorithm. */
	{
	 int i,j,flag=0;
	 printf("\nORDER OF TRAVERSAL IS : \n");
	 i=0;
	 while(flag != 1)
	 {
	   for(j=0;j<no;j++)     /*Find a node in adjacentcy matrix which is */
	   {                     /*connected to some other node*/
		if(adj[i][j] == 1)
		flag = 1;
	   }
	   i++;
	}
	if(i <= no)
	{
	  push(i-1);
	  j = i-1;
	  v[j] = 1;
	  printf("NODE%d ",j+1);
	  j = pop();
	  for(i=1;i<no;i++)
	  {
		if(adj[j][i] == 1)
		push(i);
	  }
	  search(adj,j,no);
	  flag = -1;
	  for(j = 0;j<no;j++)
	  {
		if(v[j] != 1)
		flag = j;
	  }
	  if(flag != -1)
	    printf("\nTHE GRAPH IS NOT CONNECTED");
	  getch();
	}
	else
	printf("\nTHE GRAPH IS NOT CONNECTED");
	}
/*--------------------End of dfs function---------------------------*/
	/*Push the currently working node while the adjacent nodes
		to it are visited*/

	void push(int j)
	{
	 p = malloc(sizeof(struct node));
	 p->num = j;
	 p->next = NULL;
	 if(front== rear && rear== NULL)
	 {
	   rear = p;
	   front = p;
	 }
	 else
	 {
	  rear->next=p;
	  rear = rear->next;
	 }
	}
/*-----------End of function push----------------------------------*/

	/*Pop the node to continue traversal of a particular node*/

	int pop()
	{
	 int x;
	 if(front != rear)
	 {
	   p = front;
	   x = p->num;
	   front = front->next;
	   p->next = NULL;
	   free(p);
	 }
	 else
	 {
	  p=front;
	  x = p->num;

	  free(p);
	  front = NULL;
	  rear = NULL;
	 }
	 return(x);

	}
/*-------------------End of function pop---------------------------*/

	void search(int adj[10][10],int i,int no)
	/* depthwise traversal */
	{
	  int j;
	  for(j = 0;j<no;j++)
	  {
	  if(adj[i][j] == 1 && v[j] != 1)
	  {
	       /*Recursive function to traverse in depth*/
		v[j] = 1;
		printf("NODE%d ",j+1);
		search(adj,j,no);
	  }
	}
	}

/*---------------------End of function search---------------------*/