	/* Implementation of graph colouring algorithm.

	   Program by : Mrs. Shivangi G. Potdar.                  */

#include<stdio.h>
#include<conio.h>
#define MAX 10

int m,C[MAX],Graph[MAX][MAX];


	void read_matrix(int n)
	/* read the weight graph */
	{
	  int i,j;
	  printf("\n\ Enter the adjacency matrix: \n\t");
	  for(i=1;i<=n;i++)
	  {
	    for(j=1;j<=n;j++)
	    scanf("%d",&Graph[i][j]);
	  }
	 }
	/*----------------End of function read_matrix-----------*/
	void init_array(int n)
	/* initialise the color vector to zero */
	{
	   int i;
	   for(i=1;i<=n;i++)
		C[i] = 0;
	}

	/*---------------End of function init_array--------------*/

	void print_array(n)
	{
	   int i,max=0;
	   printf("\n\n\t  The colours of the nodes are :\n\t");
	   printf("\n\t	NODE          COLOUR    \n\t");
	   printf("    ------        -------\n\t");
	   for(i=1;i<=n;i++)
	   printf("%7d %10d\n\t",i,C[i]);
	   for(i=1;i<=n;i++)
	   {
	      if(C[i] > max)
		 max=C[i];
	    }
	    printf("\n\t The number of colours used are %d\n\n",max);
		exit(0);
	}
	/*--------------End of function print_array-------------------*/

	void nextvalue(int k,int n)
	/* function to find next heighest numbered color for a node k,
	   such that this color is distinct from the adjacent node */
	{
	   int i;
	    while(1)
	  {
	    C[k] = (C[k]+1) % (m+1);  /* next heighest color */
	    if(C[k] == 0)  /* if all the colors are used */
	       return;
	    for(i=1;i <= n;i++) /* check whether rhis is a distinct color */
	    {
	       /* if there is an edge ki and both k & i have same color
		   then exit */
	      if((Graph[k][i] ==1) && (C[k] == C[i]))
	       break;
	    }
	    if(i == n+1)   /* a new color is found */
	      return;
	   }  /* else try for different color */
	}

	/*---------------End of function next value ---------------------*/

	    int  mcolouring(int k,int n)
	    /* function to find m colors for graph */
	    {
	      while(1){
	      nextvalue(k,n); /* find color for k */
	      if(C[k] == 0) /* no new color possible */
	      return(-1);
	      if(k==n)  /* all the nodes have been colored */
	      {
	      print_array(n);
	      exit(0);
	      }
	      else
	      mcolouring(k+1,n);/* yet nodes are left for coloring */
	      }
	      }

      /* end of function mcoloring*/

	      main()
	      {
		int n,x;
		clrscr();
		system("cls");
                printf("\n\n\t Enter the no of nodes to be present in the graph: ");
		scanf("%d",&n);
		read_matrix(n);
		init_array(n);

		printf("\n\t Enter the maximum number of colours tobe present in the graph");
		scanf("%d",&m);
		x=mcolouring(1,n);
		if(x==-1)
		 {
		  printf("\n Coloring was not possible ..");
		  getch();
		 }
		}


	/*------------End of function main-------------------------------*/




