    /* Program to search a number from the linked list.
       We are using sequential search.

       Programmar : Mrs. Shivangi G. Potdar.	                */


	#include<stdio.h>
	struct node
	{
	 int no;
	 struct node *next;
	};

 struct node *root;

 /*------------------------Function to create the list---------------*/

	void insert(int x)
	{
	   struct node *p,*q;
	   p=(struct node *)malloc(sizeof(struct node));
	   p->no=x;
	   p->next=NULL;
	   if (root==NULL)
	   root=p;
	   else
	   {
	     q=root;
	     while(q->next !=NULL)
	       q=q->next;
	     q->next=p;
	   }
	}

/*--------------End of function insert-------------------------------*/

	int search(int x)
	/* Function to search for x in the list */
	{
	  struct node *p;
	  int k=0,found=0;
	  p=root;
	  if (p==NULL)
	  {
	    printf("\n Empty List ");
	    return(k);
	  }
	  else
	  {
	    while ((p!=NULL) &&(found==0))
	    {
	       k++;
	       if(p->no==x)
	       {
		 found=1;
	       }
	       else
	       p=p->next;
	    }
	  }
	  if (found==0)
	  k=0;
	  return(k);
	}

/*-------------End of function search-------------------------------*/
	main()
	{
	  int y,loc,opt;
	  char ans;
	  root=NULL;
	  do
	  {
	   clrscr();
	   printf("\n\n\tLINEAR SEARCH FOR LINKED LIST");
	   printf("\n\t-----------------------------");
	   printf("\n\t\t1. Create the list ");
	   printf("\n\t\t2. Search");
	   printf("\n\t\t3. exit");
	   printf("\n\n\t....Enter your choice :");
	   scanf("%d",&opt);
	   switch(opt)
	   {
	     case 1:
		   clrscr();
		   do
		   {
		    printf("\n Enter number to be inserted ");
		    scanf("%d",&y);
		    insert(y);
		    printf("\n do you wish to add any more :");
		    ans=getch();
		    }while((ans=='y')||(ans=='Y'));
		    break;
	     case 2:
		   clrscr();
		   printf("\n\t\t Enter the number to be searched ");
		   scanf("%d",&y);
		   loc=search(y);
		   if(loc==0)
		      printf("\n Number Not found ");
		   else
		     printf("\n The number %d is present in %d location ",y,loc);
		     getch();
		     break;
	     default :
			printf("\n Improper choice ");
	    }
	   }while (opt!=3);
	}

/*----------------END OF MAIN FUNCTION---------------------------------------*/

