/* Merging Of two Sorted Files */
/* --------------------------- */

/* Including Header Files */
/* ---------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>
#include <string.h>

/* Macro Definations For Menu Options */
/* ---------------------------------- */

#define show(x,y,z,a) gotoxy(x,y);printf(z,a)
#define CH1 "1.Create-First File "
#define CH2	"2.Create-Second File"
#define CH3 "3.Append-First File "
#define CH4	"4.Append-Second File"
#define CH5	"5.Merge   "
#define CH6	"6.Print   "
#define	CH7	"7.Exit    "
#define CH(ch) ch==1?CH1:(ch==2?CH2:(ch==3?CH3:(ch==4?CH4:CHO(ch))))
#define CHO(ch) ch==5?CH5:(ch==6?CH6:CH7)

/* Function Prototypes */
/* ------------------- */

void data(int ch,char *filen);
void display(char *filen);
void merge(void);
void quicksort(int low,int high);
int partition(int low,int high);

/* Global Variable Definations */
/* --------------------------- */

FILE *fp;
struct studrec
{
	int rollno;
	char name[30],branch[15],class[7];
} e,f,*g;

/* Function Main Displays Menu */
/* --------------------------- */

void main(void)
{
	char file1[]="s1.dat";
	char file2[]="s2.dat";
	char file3[]="s3.dat";
	int ch=1,x;
	do
	{
		x=0;
		clrscr();
		printf("\n\n\n\tDemo Of Merging Of Two Sorted Files");
		printf("\n\t-----------------------------------");
		printf("\n\t1.Create-First File ");
		printf("\n\t2.Create-Second File");
		printf("\n\t3.Append-First File ");
		printf("\n\t4.Append-Second File");
		printf("\n\t5.Merge ");
		printf("\n\t6.Print ");
		printf("\n\t7.Exit  ");
		printf("\n\t---------------------");
		printf("\n\tEnter Your Choice : ");
		printf("\n\t---------------------");

		gotoxy(28,14);
		printf("%d",ch);
		gotoxy(9,5+ch);
		textcolor(BLACK);
		textbackground(LIGHTGRAY);
		cprintf(CH(ch));

		while(x!=13)
		{
			fflush(stdin);
			x=getch();

			gotoxy(9,5+ch);
			textcolor(LIGHTGRAY);
			textbackground(BLACK);
			cprintf(CH(ch));

			if(x==80)
				ch=(ch==7?1:ch+1);
			else if(x==72)
				ch=(ch==1?7:ch-1);

			gotoxy(9,5+ch);
			textcolor(BLACK);
			textbackground(LIGHTGRAY);
			cprintf(CH(ch));

			gotoxy(28,14);
			printf("%d",ch);
		}
		textcolor(LIGHTGRAY);
		textbackground(BLACK);

		switch(ch)
		{
			case 1:data(1,file1);
					 break;
			case 2:data(1,file2);
					 break;
			case 3:data(2,file1);
					 break;
			case 4:data(2,file2);
					 break;
			case 5:merge();
					 break;
			case 6:display(file1);
				   display(file2);
				   display(file3);
					 break;
		}
	}while(ch!=7);
	return;
}

/* Function Data Is For User Input To Create/Append Database */
/* --------------------------------------------------------- */

void data(int ch,char *filen)
{
	int i=6,j;
	if(ch==1)
	{
		if( (fp=fopen(filen,"w") )==NULL )
		{
			printf("\n\tSystem Error!!!");
			getch();
			exit(0);
		}
	}
	else
	{
		if( (fp=fopen(filen,"a") )==NULL )
		{
			printf("\n\tSystem Error!!!");
			getch();
			exit(0);
		}
	}
	clrscr();
	printf("\n\tEditing File - %s   Enter Roll No -1 For Exit!!!",filen);
	printf("\n\n\tRoll no. Name                          ");
	printf("Branch         Class");
	e.rollno=0;
	while(e.rollno!=-1)
	{
		gotoxy(9,i);
		scanf("%d",&e.rollno);
		if(e.rollno==-1)
			break;
		fflush(stdin);
		gotoxy(18,i);
		gets(e.name);
		gotoxy(48,i);
		gets(e.branch);
		gotoxy(63,i);
		gets(e.class);
		fwrite(&e,sizeof(e),1,fp);
		i++;
		if(i==22)
		{
			i=6;
			clrscr();
			printf("\n\tEditing File - %s   Enter Roll No -1 For Exit!!!",filen);
			printf("\n\n\tRoll no. Name                          ");
			printf("Branch         Class");
		}
	}
	fclose(fp);
	return;
}

/* Function Display Prints File Contents */
/* ------------------------------------- */

void display(char *filen)
{
	int i=6;

	if( (fp=fopen(filen,"r"))==NULL )
	{
		printf("\n\tSystem Error!!!");
		getch();
		exit(0);
	}
	else
	{
		clrscr();
		printf("\n\n\tPrinting The File - %s\n",filen);
		printf("\n\tRoll no. Name                          ");
		printf("Branch         Class");
		while(!feof(fp))
		{
			if(fread(&e,sizeof(e),1,fp)==1)
			{
				show(9,i,"%d",e.rollno);
				show(18,i,"%s",e.name);
				show(48,i,"%s",e.branch);
				show(63,i,"%s",e.class);
				i++;
				if(i==21)
				{
					getch();
					clrscr();
					printf("\n\n\tPrinting The File - %s\n",filen);
					printf("\n\n\tRoll no. Name                          ");
					printf("Branch         Class");
					i=5;
				}
			}
		}
	}
	fclose(fp);
	getch();
	return;
}

/* Functiuon Merge Will Combine The Two Files */
/* ------------------------------------------ */

void merge(void)
{
	int n1=0,n2=0,k;
	FILE *fp1,*fp2,*fp3;
	if( (fp1=fopen("s1.dat","r+") )==NULL )
	{
		printf("\n\tSystem Error!!!");
		getch();
		exit(0);
	}
	if( (fp2=fopen("s2.dat","r+") )==NULL )
	{
		printf("\n\tSystem Error!!!");
		getch();
		exit(0);
	}
	if( (fp3=fopen("s3.dat","w") )==NULL )
	{
		printf("\n\tSystem Error!!!");
		getch();
		exit(0);
	}
	while(!feof(fp1))
	{
		if(fread(&e,sizeof(e),1,fp1)==1)
			n1++;
	}
	rewind(fp1);

	g=(struct studrec *)malloc(sizeof(f)*n1);
	fread(g,sizeof(f),n1,fp1);
	rewind(fp1);
	quicksort(0,n1-1);
	fwrite(g,sizeof(f),n1,fp1);
	rewind(fp1);
	free(g);

	while(!feof(fp2))
	{
		if(fread(&f,sizeof(f),1,fp2)==1)
			n2++;
	}
	rewind(fp2);

	g=(struct studrec *)malloc(sizeof(f)*n2);
	fread(g,sizeof(f),n2,fp2);
	rewind(fp2);
	quicksort(0,n2-1);
	fwrite(g,sizeof(f),n2,fp2);
	rewind(fp2);
	free(g);

	fread(&e,sizeof(e),1,fp1);
	fread(&f,sizeof(f),1,fp2);

	while( !feof(fp1) && !feof(fp2) )
	{
		if(e.rollno < f.rollno)
		{
			fwrite(&e,sizeof(e),1,fp3);
			fread(&e,sizeof(e),1,fp1);
		}
		else
		{
			fwrite(&f,sizeof(f),1,fp3);
			fread(&f,sizeof(f),1,fp2);
		}
	}

	while(!feof(fp1))
	{
		fwrite(&e,sizeof(e),1,fp3);
		fread(&e,sizeof(e),1,fp1);
	}
	while(!feof(fp2))
	{
		fwrite(&f,sizeof(f),1,fp3);
		fread(&f,sizeof(f),1,fp2);
	}

	fclose(fp1);
	fclose(fp2);
	fclose(fp3);
	return;
}

/* Function Quicksort Will Now Sort The Data Recursively */
/* ----------------------------------------------------- */

void quicksort(int low,int high)
{
	int mid;
	if(low >= high)
		return;
	mid=partition(low,high);

	quicksort(low,mid-1);
	quicksort(mid+1,high);
	return;
}

/* Function Partition Will Divide & Return The Pivot Location */
/* ---------------------------------------------------------- */

int partition(int low,int high)
{
	int mid,i;

	mid=(low+high)/2;
	f=g[low];
	g[low]=g[mid];
	g[mid]=f;

	mid=low;
	for(i=low+1;i<=high;i++)
	{
		if(g[i].rollno < g[low].rollno)
		{
			f=g[mid+1];
			g[mid+1]=g[i];
			g[i]=f;
			mid++;
		}
	}

	f=g[low];
	g[low]=g[mid];
	g[mid]=f;

	return(mid);
}