/*  This program is to implement quick sort.
    The simple array of numbers is an input.

    Programmar : Mrs. Shivangi G. Potdar.                           */

	#include<stdio.h>
	#define MAX 10
	int l[MAX];
/*---------------------Function to swap the two numbers-------------*/

	void swap(int x,int y)
	{
	  int t;
	  t=l[x];
	  l[x]=l[y];
	  l[y]=t;
	}
/*-------------------Function to partition the list----------------*/

	int partition(int low,int high)
	{
	 int pivotloc,pivot,i,lastsmall;
	 swap(low,(low+high)/2);   /* take the middle element of the
			      list and place it in first position  */
	pivot=l[low];
	lastsmall=low;
	for(i=low+1;i<=high;i++)
	{
	  if(l[i] < pivot) /* place all elements less than pivot to
			      its left */
	  {
	   lastsmall=lastsmall+1;
	   swap(lastsmall,i);
	  }
	}
	 swap(low,lastsmall);  /* place pivotal element in its proper
				  place */
	 pivotloc=lastsmall;
	 return(pivotloc);
	}
/*------------End of partition function-----------------------------*/

	 void sort(int low,int high)
	 /* function to sort the numbers by successively
	   dividing it in sublists */
	 {
	   int pivotloc;
	   if(low<high)
	   {
	    pivotloc=partition(low,high);
	    sort(low,pivotloc-1);
	    sort(pivotloc+1,high);
	   }
	 }
/*----------End of sort function---------------------------------*/

	 main()
	 {
	   int n,i,x;
	   char ans;
	   do
	   {
	     clrscr();
	     printf("\n Enter how many numbers you wish to sort");
	     scanf("%d",&n);
	     for(i=1;i<=n;i++)
	     {
	     printf("\n Enter the number :");
	     scanf("%d",&x);
	     l[i]=x;
	     }
	     sort(1,n);
	     printf("\n\t\t SORTED NUMBERS ARE ");
	     for(i=1;i<=n;i++)
	     printf("\n\t\t %d",l[i]);
	     printf("\n Do you wish to try again ");
	     ans=getch();
	    }while(ans=='Y' || ans=='y');
	  }

/*--------------End of main function-----------------------------------*/