	 /* Program to implement queue using linked list
	    Note that the start and rear are the two pointers
	    to point to the start and end of the queue.

	     Programmar : Mrs. Shivangi. G. Potdar           */

	 #include<stdio.h>
	 #include<stdlib.h>
	 #include<conio.h>

	 struct node
	 {
	  int info;
	  struct node *rll,*ll;
	 }*p,*q,*start,*r;

	void add_queue(void);
	void display_queue(void);
	void delete_queue(void);

	void main()
	{
	  char ch,ch1;
	  int y;
	  start=NULL;
	  do            /*Displaying Menu */
	  {
		clrscr();
		printf("\t------QUEUE USING LINKED  LIST--------\n");
		gotoxy(9,2);
		printf("1>  ADD AN ELEMENT TO QUEUE\n\n");
		printf("\t2>  DISPLAY QUEUE\n\n");
		printf("\t3>  DELETE AN ELEMENT FROM QUEUE\n\n");
		printf("\t4>  QUIT");
		gotoxy(9,2);
		for(;;)             /* Loop for arrow keys */
		{
			ch = getch();
			if(ch == 13)
				break;
			if(ch == 0)
			{
				ch = getch();
				if(ch == 80)
				{
					y = wherey();
					gotoxy(9,y+2);
				}
				if(ch == 72)
				{
					y = wherey();
					gotoxy(9,y-2);
				}
			}
		}
		switch(wherey())
		{
			case 2 : add_queue();
					 break;
			case 4 : display_queue();
					 break;
			case 6 : delete_queue();
					 break;
			case 8 : exit(1);
					 break;
			default: printf("\nWrong choice!!!!\n");
					 break;
		}
		printf("\nDo you want to continue?[y/n]\n");
		flushall();
		ch1 = getch();
	  }while(ch1 == 'y' || ch1 == 'Y');
	}

	void add_queue(void)
	/* Function to add an element to queue */
{
	char ch;
	clrscr();
		p = malloc(sizeof(struct node));
		printf("\n\n\n\tEnter data\n");
		scanf("%d",&p->info);
		p->rll = NULL;
		p->ll=NULL;
		if(start == NULL)
		{
			start= p;
			}
		else
		{       r=start;
			while(r->rll != NULL)
			  r=r->rll;
			r->rll=p;
			p->ll=r;
		}
}
void display_queue(void)       /* Displaying the queue */
{
	clrscr();
	q = start;
	if(q == NULL)  /*Check for empty condition */
		printf("\n THE QUEUE IS EMPTY\n");
	else
	{
		printf("\n\n\n");
		while(q !=NULL)
		{
			printf("%d\t",q->info);
			q = q->rll;
		}
	}
	getch();
}
void delete_queue(void)            /* Deleting number from queue */
{               int num,found=0;
	clrscr();
	q = start;
	if(q == NULL)         /* Check for empty condition */
		printf("\n\nTHE QUEUE IS EMPTY!!\n");
	else
	{
	   printf("Enter the number to be deleted ");
	   scanf("%d",&num);
	   while ((found ==0 ) && (q != NULL))
	   { if (q->info == num )
		 found=1;
	     else
		q=q->rll;
	   }
	   if (found==0)
	   {
	     printf("\n Number not found ");
	     getch();
	   }
	   else
	   {
	     if (q==start)
		{
		  start=start->rll;
		  q->rll=NULL;
		  start->ll=NULL;
		  free(q);
		}
	     else
		{
		  (q->rll)->ll=q->ll;
		  ( q->ll)->rll=q->rll;
		  q->ll=NULL;
		  q->rll=NULL;
		  free(q);
		}
	}
}

}