	  /* This program is to implement simple binary tree.
	     We just create the tree and traverse it.
	     Data here is names.

	     Program by : Mrs. Shivangi G. Potdar.           */


	# include <stdio.h>     /* HEADER FILES */
	# include <conio.h>
	# include <dos.h>
	# include <string.h>
	# include <stdlib.h>

	struct node       /* STRUCTURE FOR EACH NODE */
	{
	  char data[15];
	  struct node *left,*right;
	};

	void insert(struct node *,struct node *);
	void tree(struct node *,int);

	void main()
	{
	   int choice,c,i,flag;
	   char temp='N',temp1[15];
	   struct node *s,*root,*r,*q;
	   root=NULL;
	   do
	   {
	    clrscr();
	    printf("\n\t\t 1.> ENTER     ");
	    printf("\n\t\t 2.> DISPLAY ->");
	    printf("\n\t\t 3.> EXIT      ");
	    printf("\n\n\t\t Enter your choice :");
	    scanf("%d",&choice);
	    switch(choice)
	    {
	      case 1:
		     root=NULL;
			   /* INSERTION OF NODE */
		 printf("****** DATA ENTRY ******\n");
		 do
		 {
		  s=malloc(sizeof(struct node));
		  s->left=NULL;
		  s->right=NULL;
		  printf("\n ENTER DATA : ");
		  scanf("%s",&s->data);
		  if(root==NULL)     /* TREE is empty */
			 root=s;
		  else
		     insert(root,s);
		 printf("\n ENTER MORE ELEMENTS (Y/N) : ");
		 scanf("\n%c",&temp);
		}while(temp=='y');
		break;

	      case 2:
		    clrscr();
		    do{
		       clrscr();
		       printf("\n\t 1.> PREORDER");
		       printf("\n\t 2.> INORDER");
		       printf("\n\t 3.> POSTORDER");
		       printf("\n\t 4.> EXIT      ");
		       printf("\n\t Enter your choice :");
		       scanf("%d",&c);
			if(root==NULL)  /* TREE EMPTY CONDITION */
			  printf("< TREE NOT STARTED YET >");
			else
			tree(root,c);
			printf("\n\n PRESS ANY KEY TO CONTINUE ......");
			getch();
		      }while(c!=4);
		break;
	    }
	   }while(choice!=3);
	}

/*-------------------End of Main function----------------------------*/

	void insert(struct node *r,struct node *p)
	/* FUNCTION FOR INSERTION */
	{
	 char ans;
	 printf("\n wish to insert left/right of %s",r->data);
	 ans=getch();
	 if ((ans=='r')||(ans=='R'))  /* insert to right */
	 {
	    if(r->right==NULL)
	     {
		 r->right=p;
	     }
	    else
		 insert(r->right,p);
	 }
	 else  /* insert left */
	 {
	  if (r->left==NULL)
	  {
	       r->left=p;
	  }
	 else
	      insert(r->left,p);   /* RECURSIVE CALL*/
	 }

	}
/*-------------End of insert function-------------------------------*/

	void tree(struct node *r,int c)

	/* FUNCTION FOR TRAVERSAL */

	{
	  int top,flag;
	  struct node *w,*stack[20];
	  if(r!=NULL)
	  {
	   if(c!=4)
	   {
	     if(c==1)
		printf("  %s  ",r->data);
		tree(r->left,c);
	     if(c==2)
		printf("  %s  ",r->data);
		tree(r->right,c);
		if(c==3)
			printf("  %s  ",r->data);
	   }
	  }
	}

/*-------------------End of tree function---------------------------*/