	/* PROGRAM FOR CREATION AND TRAVERSAL OF THREADED TREE .
	   Uses complete thread.
	   Program by : Mrs. Shivangi G. Potdar.	     */


	# include <stdio.h>   /* HEADER FILES */
	# include <conio.h>
	# include <dos.h>
	# include <stdlib.h>

	struct node    /* STRUCTURE FOR EACH NODE */
	{
	  int info;
	  int tleft,tright;
	  struct node *left,*right;
	};

/*-----------------------End of declarations------------------------*/

	void main()
	{
	  int choice,flag;
	  struct node *root,*s,*p,*q,*header=NULL;
	  char cont;
	  root=NULL;

	  do
	  {
	    clrscr();
	    printf("\n\t\t ...... THREADED BINARY TREES .......	\n\n");
	    printf("\t 1.> ADD NEW ELEMENTS \n");
	    printf("\t 2.> INORDER TRAVERSAL\n");
	    printf("\t 3.> EXIT\n");

	    printf("\n \t\tENTER CHOICE : ");
	    scanf("%d",&choice); /* CHOICE OF OPERATION */

	    switch(choice)
	    {
		case 1:
			 /* IF CHOICE IS INSERTION */

			clrscr();
			printf("\t\t\... DATA ENTRY OPERATION ...\n\n");

			do
			{
			 s=malloc(sizeof(struct node));
			 printf("\n ENTER DATA : ");
			 scanf("%d",&s->info);     /* DATA TO BE ENTERED */

			 if(root==NULL)   /* ROOT NULL CONDITION */
			 {
			   root=s;
			   root->right=header;
			   root->left=header;
			   root->tright=1;
			   root->tleft=1;
			}
			else
			{
			 q=root;
			 flag=0;
			 while(flag!=1)

			 /* USING FLAG TO INDICATE INSERTED */

			{
			  if(q->info==s->info)
			   {
			     printf("\n%d ..already exists..",q->info);
			     flag=1;
			   }
			  else
			  {
			 if(q->info < s->info&&q->tright==0)
			 /* MOVING RIGHT */
			 {
			   q=q->right;
			 }
			 else
			   if(q->info > s->info && q->tleft==0)
			   /* MOVING LEFT */
			    {
				q=q->left;
			    }
			 else

			   if(q->info < s->info&&q->tright==1)
			   {
				flag=1;
			   }
			 else

			  if(q->info > s->info&&q->tleft==1)
			  {
				flag=1;
			  }
			  }
			}

			if(q->info<s->info&&q->tright==1)
			 /* IF INSERTION TO LEFT */
			{
			   p=q->right;
			   q->right=s;
			   q->tright=0;
			   s->right=p;
			   s->left=q;
			   s->tright=1;
			   s->tleft=1;
			 }
			else

			if(q->info>s->info&&q->tleft==1)
			/* IF INSERTION TO RIGHT */
			{
			      p=q->left;
			      q->left=s;
			      q->tleft=0;
			      s->left=p;
			      s->right=q;
			      s->tright=1;
			      s->tleft=1;
			 }
			}
			 printf("\n ENTER MORE (y/n) : ");
			 scanf("\n%c",&cont);

			}while(cont!='n');

			/* CONDITION TO CONTINUE */

			  break;

		case 2:
			/* CHOICE TO TRAVEL */

			 clrscr();
			 printf(" ------ TRAVERSAL ------	\n\n");
			 p=root;
			 flag=0;

			 while(p!=header)
			 {
			   while(flag==0&&p->tleft==0)
			   {
				  p=p->left;
			   }
			   printf(" %d ",p->info);
			   if(p->tright==0)
			   {
				 p=p->right;
				 flag=0;
			   }
			   else
			   {
			     p=p->right;
			     flag=1;
			   }
			 }

			 printf("\n\n PRESS ANY KEY TO MAIN MENU ......");
			 getch();
			 break;

		default :
			if(choice!=3)
			{
			   printf("\n\n WRONG CHOICE RE-ENTER");
			   getch();
			}
			break;

	    }

	  }while(choice!=3);/* CONDITION TO CONTINUE */

	}



/*------------------End of main function----------------------------*/
