{PROGRAM :Breadth First Traversal of Graph}

PROGRAM BFS;

    type
       arr1=array[0..10,0..10]of integer;  {adjacency matrix}

       ptr=^queue;
       queue=record   {record to store information in the queue}
              n   :integer;
              next:ptr;
             end;

    arr2=array[0..10] of integer;


  VAR

    i,j,ch1,s,node:INTEGER;
    adj:arr1;
    front,rear,p:ptr;
    nodename:string[10];

{-------------------------end of declarations-------------------------}

    { FUNCTION TO ADD INTO QUEUE }
     procedure addqueue(i:integer);
     begin
         NEW(p);
         p^.n := i;
         p^.next := NIL;
         if((front = NIL) and (rear = NIL)) then
         begin
             front := p;
             rear:=p;
         end
         else
           begin
               rear^.next := p;
               rear := rear^.next;
           end;
      end;

{---------------------------end of function addqueue-------------------}

     { FUNCTION TO DELETE FROM QUEUE }
     function deletequeue:integer;
     var
        i:integer;
     begin
         p := front ;
         front := front^.next;
         if(front = NIL) then
            rear := NIL;
         i := p^.n;
         p^.next := NIL;
         dispose(p);
         deletequeue:=i;
     end;

{--------------------------end of function deletequeue------------------}

    procedure  visit(index:integer);
    begin
        writeln('node   ',nodename[index]);
        readln;
    end;

{-----------------------end of function visit----------------------------}

    procedure bfs(node:integer;adj:arr1);
    {procedure for BFS algorithm}

    var

       i,j,v:integer;
       inqueue,visited:array[1..10] of integer;
     begin
          for i := 0 to node-1 do
          begin     { INITIALIZE VISITED AND INQUEUE ARRAYS }
              visited[i] := 0;
              inqueue[i]:=0;
          end;
          front := NIL;
          rear := NIL;   { INITIALIZE QUEUE }
          for  i :=0 to node-1 do
          begin
            if(visited[i] <>1) then { CHECK IF NODE IS VISITED }
            begin
                addqueue(i);  { ADD NODE IN QUEUE }
                inqueue[i] := 1;
                while (front <> NIL) do
                begin
                  v := deletequeue;  { REMOVE FIRST QUEUE ELEMENT }
                  visited[v] := 1;    { MARK VISITED }
                  visit(v);          { VISIT NODE }
                  for j:= 0 to node-1 do
                  begin
                      { CHECK THE NEIGHBOUR'S OF THE NODE }
                      { IF THEY ARE NOT VISITED THEN PUSH ONTO QUEUE }
                     if((adj[i,j] = 1) and (visited[j] <> 1) and (inqueue[j] <> 1)) then
                     addqueue(j );
                     inqueue[j] := 1;
                  end;
                 end;
              end;
            end;
     end;

{-----------------------end of procedure bfs-----------------------------}

    BEGIN  {MAIN}
        ch1:=1;
        while((ch1<>2)) do
        begin
        clrscr;
        writeln('     MENU  ');
        writeln('1. BREADTH FIRST');
        writeln('2. EXIT');
        readln(ch1);
        clrscr;
        CASE CH1 OF
           1:begin
                write(' ENTER THE NUMBER OF NODES : ');
                readln(node);
        for i:= 0 to node-1 do         {ACCEPT NODE NAMES FROM USER }
        begin
           write('NAME OF NODE  - ',i+1,'  ');
           readln(nodename[i]);
        end;

         {ACCEPT ADJACENCY MATRIX FROM USER }
        clrscr;
        writeln('ENTER ADJACENCY MATRIX');
        gotoxy(22,5);
        for i:=0 to node-1 do
          write(' node  ',nodename[i]);
        gotoxy(7,6);
        writeln(' ');
        for i:=0 to node-1 do
          writeln('node ',nodename[i]);

        writeln;
        writeln;
        writeln;

        for i :=0 to node-1 do
        begin
            for j:=0 to node-1 do
            begin
               gotoxy(25+(6*j),7+(3*i));
               if(i=j) then
                 writeln('0')
               else
                 readln(adj[i,j]);
            end;
        end;
         WRITELN('':10,' B F S TRAVERSAL IS :');
         bfs(node,adj);
      end;

          end;
        end;
    END.


{----------------------END OF MAIN-----------------------------------------}



