
{         PROGRAM : To implement simple binary tree     }

         PROGRAM BINARY_TREE;

         TYPE TYP = STRING[20];  {maximum string length}
              PTR=^NODE;         {define the node structure}
              NODE = RECORD
                     NAME :TYP;
                     RT,LT:PTR;
                     END;

         VAR
            NAME,TARGET :TYP;
            ROOT,P,Q    :PTR;
            CH          :CHAR;
            OPT         :INTEGER;
            DELIT       :TYP;
            C           :CHAR;

{------------------end of declarations-------------------------------}

         PROCEDURE GETNODE(VAR P:PTR);
         {procedure to read a new key}
         VAR
            ITEM :TYP;
         BEGIN
              NEW(P);
              WITH P^ DO
              BEGIN
                WRITE('ENTER ITEM ');
                READLN(ITEM);
                NAME:=ITEM;
              END;
         END;

{----------------end of procedure GETNODE----------------------------}

         PROCEDURE INSERT(VAR ROOT:PTR;NEWNODE:PTR);
         {procedure to insert a new node}
         VAR
             Q,R :PTR;
             OPT1:INTEGER;
         BEGIN
            IF ROOT=NIL THEN  {it is the first node}
            BEGIN
                ROOT:=NEWNODE;
                ROOT^.LT:=NIL;
                ROOT^.RT:=NIL;
            END
            ELSE              {if there are few nodes in tree}
               BEGIN
                   R:=ROOT;
                   WITH R^ DO
                   BEGIN
                      WRITE(R^.NAME,' WISH TO INSERT TO ITS RIGHT OR LEFT');
                      READLN(OPT1);
                      IF (OPT1=1) THEN
                         INSERT(LT,NEWNODE)
                      ELSE
                         INSERT(RT,NEWNODE)
                   END;
                END;
         END;

{-----------------end of procedure insert-------------------------------}

         PROCEDURE PREORD(ROOT:PTR);
         {procedure for inorder traversal}
         BEGIN
            IF ROOT <> NIL THEN
            BEGIN
                WRITELN(ROOT^.NAME);
                PREORD(ROOT^.LT);
                PREORD(ROOT^.RT);
             END;
         END;
{--------------end of procedure PREORD--------------------------------}


         PROCEDURE INORD(ROOT:PTR);
         {procedure for inorder traversal}

         BEGIN
            IF ROOT <> NIL THEN
            BEGIN
                INORD(ROOT^.LT);
                WRITELN(ROOT^.NAME);
                INORD(ROOT^.RT);
            END;
         END;
{--------------end of procedure INORD------------------------------------}

         PROCEDURE POSTORD(ROOT:PTR);
         {procedure for postorder traversal}
         BEGIN
            IF ROOT <> NIL THEN
            BEGIN
                POSTORD(ROOT^.LT);
                POSTORD(ROOT^.RT);
                WRITELN(ROOT^.NAME);
            END;
         END;
{--------------end of procedure POSTORD------------------------------------}

         BEGIN{MAIN}
             ROOT:=NIL;
             CLRSCR;
             REPEAT
                WRITELN('PRESS ANY KEY TO CONTINUE ');
                READ(KBD,C);
                CLRSCR;
                GOTOXY(20,10);
                WRITELN('M E N U');
                WRITELN;
                WRITELN('':10,'1. INSERT');
                WRITELN('':10,'2. PREORDER');
                WRITELN('':10,'3. INORDER');
                WRITELN('':10,'4. POSTORDER');
                WRITELN('':10,'0. EXIT');
                READLN(OPT);
                CASE OPT OF
                   1: BEGIN
                        REPEAT
                          GETNODE(P);
                          INSERT(ROOT,P);
                          WRITE('TRY ');
                          READLN(CH);
                         UNTIL CH='N';
                       END;

                    2: PREORD(ROOT);

                    3:INORD(ROOT);

                    4:POSTORD(ROOT);
                END;
             UNTIL OPT=0;
         END.


{--------------------end of MAIN-------------------------------------}
