begin
write('ѥ');
end.
RCE PROGRAM

         PROGRAM : IMPLEMENTATION OF BINARY SEARCH TREE. }


           PROGRAM BSTREE;

           TYPE TYP = STRING[20]; {Maximum string length}

           PTR  =^NODE;      {define the node structure}
           NODE = RECORD
                  NAME :TYP;
                  RT,LT:PTR;
                  END;

           VAR
              NAME,TARGET :TYP;
              ROOT,P,Q    :PTR;
              CH          :CHAR;
              OPT         :INTEGER;
              DELIT       :TYP;
              C           :CHAR;

{---------------------End of declaration part------------------------}

           PROCEDURE GETNODE(VAR P:PTR);
           { To create a new node }

           VAR
             ITEM :TYP;

            BEGIN
               NEW(P);
               WITH P^ DO
               BEGIN
                   WRITE('ENTER ITEM ');
                   READLN(ITEM);
                   NAME:=ITEM;
               END;
          END;

{---------------------End of procedure GETNODE-----------------------}

         PROCEDURE INSERT(VAR ROOT:PTR;NEWNODE:PTR);
         {Procedure to insert a new node}

         VAR
            Q:PTR;
         BEGIN
             IF ROOT=NIL THEN   {if it is a first node }
             BEGIN
                   ROOT:=NEWNODE;
                   ROOT^.LT:=NIL;
                   ROOT^.RT:=NIL;
             END
             ELSE    {there are few nodes in tree}
                WITH ROOT^ DO
                IF NEWNODE^.NAME < NAME THEN
                    INSERT(LT,NEWNODE)
                ELSE
                    IF NEWNODE^.NAME > NAME THEN
                     INSERT(RT,NEWNODE)
                    ELSE
                     WRITELN('DUPLICATE KEY');
         END;
{------------------end of procedure insert--------------------------}

         PROCEDURE PREORD(ROOT:PTR);
         {Recursive procedure for preorder traversal}
         BEGIN
                 IF ROOT <> NIL THEN
                 BEGIN
                       WRITELN(ROOT^.NAME);
                       PREORD(ROOT^.LT);
                       PREORD(ROOT^.RT);
                 END;
         END;

{------------------end of procedure PREORD-------------------------}

         PROCEDURE INORD(ROOT:PTR);
         {procedure for inorder traversal}
         BEGIN
            IF ROOT <> NIL THEN
            BEGIN

                  INORD(ROOT^.LT);
                  WRITELN(ROOT^.NAME);
                  INORD(ROOT^.RT);
            END;
         END;

{------------------end of procedure INoRD---------------------------}

         PROCEDURE POSTORD(ROOT:PTR);
         BEGIN
            IF ROOT <> NIL THEN

            BEGIN
                POSTORD(ROOT^.LT);
                POSTORD(ROOT^.RT);
                WRITELN(ROOT^.NAME);
            END;
         END;
{------------------end of procedure POSTORD-------------------------}

         PROCEDURE DELT(VAR ROOT:PTR;IT:TYP);
         {Procedure to delete a node }

         VAR
            R,S:PTR;
            I,FLAG:INTEGER;

         BEGIN
            S:=ROOT;
            I:=0;
            FLAG:=0;

            WHILE ((FLAG=0) AND (S <> NIL)) DO
            BEGIN
               IF (S^.NAME < IT) THEN  {if the key to be deleted is in
                                         right subtree}
               BEGIN
                    R:=S;
                    S:=S^.RT;
                    I:=1;
               END;

            IF (S^.NAME > IT) THEN {key to be deleted is in left subtree}
            BEGIN
                 R:=S;
                 S:=S^.LT;
                 I:=2;
            END;

            IF (S^.NAME=IT) THEN  {key is found}
            BEGIN
                FLAG:=1;
            IF(I=0) THEN
            BEGIN
                IF (ROOT^.RT <> NIL) THEN
                BEGIN
                     Q:=ROOT^.LT;
                     ROOT:=ROOT^.RT;
                     INSERT(ROOT,Q);

                 END;

                IF (ROOT^.RT=NIL) THEN
                    ROOT:=ROOT^.LT;
           END
           ELSE
           BEGIN
               IF (I=1) THEN  {right subtree must be adjusted}
               BEGIN

                Q:=S^.LT;
                R^.RT:=S^.RT;
                IF (S^.LT <> NIL) THEN
                     INSERT(R,Q);
               END;
              IF (I=2) THEN    {left subtree must be adjusted}
               BEGIN
                  Q:=S^.RT;
                  R^.LT:=S^.LT;
                  IF (S^.RT <> NIL ) THEN
                      INSERT(R,Q);
               END;
             END;
           END;
          END;
         END;

{------------------end of procedure DELETE-------------------------}

         PROCEDURE SEARCH(ROOT:PTR;TARGET:TYP;VAR Q:PTR);
         {procedure to search for a give key in the tree }

         VAR
           FOUND:BOOLEAN;
         BEGIN
              Q:=ROOT;
              FOUND:=FALSE;
              WHILE (Q<> NIL) AND (NOT FOUND) DO
              BEGIN
              IF (Q^.NAME = TARGET) THEN
                  FOUND:=TRUE
              ELSE
                 IF (Q^.NAME < TARGET) THEN {the key being searched is}
                       Q:=Q^.RT              {in the right subtree}
                 ELSE
                 IF (Q^.NAME > TARGET) THEN  {key is in left subtree}
                 Q:=Q^.LT
             END;
                 IF FOUND=TRUE THEN
                   WRITELN('THE GIVEN KEY IS FOUND IN THE TREE')
                 ELSE
                   WRITELN('KEY IS NOT PRESENT IN THE TREE');
          END;

{------------------end of procedure SEARCH-------------------------------}


         BEGIN  {MAIN}
             ROOT:=NIL;
             CLRSCR;
             REPEAT
                WRITELN('PRESS ANY KEY TO CONTINUE ');
                READ(KBD,C);
                CLRSCR;
                GOTOXY(20,10);
                WRITELN('M E N U');
                WRITELN;
                WRITELN('':10,'1. INSERT ');
                WRITELN('':10,'2. PREORDER');
                WRITELN('':10,'3. INORDER ');
                WRITELN('':10,'4. POSTORDER');
                WRITELN('':10,'5. DELETE');
                WRITELN('':10,'6. SEARCH');
                WRITELN('':10,'0 EXIT');
                WRITELN;
                WRITELN;
                WRITE('':10,'...Your Choice  ');
                READLN(OPT);

               CASE OPT OF
                           1: BEGIN
                                REPEAT
                                   GETNODE(P);
                                   INSERT(ROOT,P);
                                   WRITE('TRY ');
                                   READLN(CH);
                                 UNTIL CH='N';
                               END;

                            2: PREORD(ROOT);

                            3:INORD(ROOT);

                            4:POSTORD(ROOT);

                            5: BEGIN
                                  WRITELN('DELETE');
                                  READLN(DELIT);
                                  DELT(root,delit);
                                END;

                             6: BEGIN
                                  WRITELN('TARGET');
                                  READLN(TARGET);
                                  SEARCH(ROOT,TARGET,Q);
                                END;
               END;
             UNTIL OPT=0;
         END.

{-------------------------END OF MAIN--------------------------------}


{                       SOURCE PROGRAM

         PROGRAM : IMPLEMENTATION OF BINARY SEARCH TREE. }


           PROGRAM BSTREE;

           TYPE TYP = STRING[20]; {Maximum string length}

           PTR  =^NODE;      {define the node structure}
 