{Traversal of graph using DFS algorithm}

    PROGRAM DFS;
    type
       arr1=array[0..10,0..10]of integer;  {adjacency matrix}

       arr2=array[0..10] of integer;  {visited nodes }


    VAR
       i,j,ch1,s,node:INTEGER;
       adj           :arr1;
       nodename      :string[10];
       ch            :char;

{--------------------------end of declarations-----------------------}

    procedure  visit(index:integer);
    begin
        writeln('node   ',nodename[index]);
        readln;
    end;

{----------------------------end of procedure visit-------------------}

    procedure traverse(index:integer;node:integer;adj:arr1;var visited:arr2);
    {procedure for traversal }
    var
      j:integer;
    begin
       visited[index] := 1;  { MARK NODE AS VISITED }
       visit(index);        { VISIT THE NODE }
       for  j := 0 to node-1 do
       begin
           {CHECK THE NEIGHBOUR'S OF THE NODE &
             IF THEY ARE NOT VISITED THEN VISIT THEM}
            if((adj[index,j] = 1) and (visited[j] <> 1)) then
               traverse(j,node,adj,visited);
        end;
     end;

{-----------------end of procedure traverse----------------------------}

    procedure dfs(node:integer;adj:arr1);
    {procedure for DFS algorithm}

    var
      visited:arr2;
      v,i,j:integer;
    begin

        for i:=0 to node-1 do  { INITIALIZE VISITED ARRAY }
             visited[i] := 0;
        for i:=0 to node-1 do
        begin
          if(visited[i] <> 1) then    { CHECK IF NODE HAS BEEN VISITED }
          traverse(i,node,adj,visited);
        end;
     end;

{-----------------------end of DFS procedure--------------------------}

BEGIN {MAIN}
    ch :='y';
    while((ch ='y') or (ch='Y')) do
    begin
        clrscr;
        write('ENTER THE NUMBER OF NODES  ');
        readln(node);
        for i:= 0 to node-1 do         {ACCEPT NODE NAMES FROM USER }
        begin
            write('NAME OF NODE  - ',i+1,' ');
            readln(nodename[i]);
        end;

        {ACCEPT ADJACENCY MATRIX FROM USER }
        clrscr;
        writeln('ENTER ADJACENCY MATRIX');
        gotoxy(22,5);
        for i:=0 to node-1 do
          write(' node  ',nodename[i]);
        gotoxy(7,6);
        writeln(' ');
        for i:=0 to node-1 do
           writeln('node ',nodename[i]);
        writeln;
        writeln;
        writeln;

          for i:=0to node-1 do
          begin
              for j:=0 to node-1 do
               begin
                 gotoxy(25+(6*j),7+(3*i));
                 if(i=j) then
                    writeln('0')
                 else
                    readln(adj[i,j]);

               end;
           end;
           readln;
           clrscr;
           writeln('     MENU  ');
           writeln('1. DEPTH FIRST ');
           writeln('2.EXIT');
           readln(ch1);
           clrscr;
           case ch1 of

                    1 :
                       begin
                        writeln('DEPTH FIRST TRAVERSAL ');
                        dfs(node,adj);
                       end;

            end;
            gotoxy(20,24);
            write('DO YOU WISH TO CONTINUE ? (Y?N) ');
            readln(ch);
          end;
    end.

{-----------------------END OF MAIN PROGRAM-----------------------------}






