 { program too sort roll numbers in the list of
                  student records,using heap sort method.

         Programmer : Mrs. Shivangi G. Potdar.                 */}

         PROGRAM HEAPS;

         CONST MAX=10;{   /* Maximum number of students */}
         TYPE
             ARR1 = ARRAY[0..MAX] OF INTEGER;
         VAR
           n,i  :INTEGER;
           stud :ARR1;
           ANS  :char;

{----------------end of declarations--------------------------------}

         PROCEDURE heapsort(VAR stud:ARR1;n:INTEGER);
         {/* Function for heap sort */}
         VAR
           i,element,heap_pos,loc,ivalue:INTEGER;
         BEGIN


            for i:=1 TO N-1 DO          { create the initial heap }
              BEGIN
                 element:=stud[i];
                 heap_pos:=i;     { insert the element in the descending
                                   list in the path formed from the root
                                   to leaf i }
                  loc:=ROUND((heap_pos-1)/2);
                  while ((heap_pos>0) AND (stud[loc]<element)) DO
                  BEGIN
                      stud[heap_pos]:=stud[loc];
                      heap_pos:=loc;
                      loc:=ROUND((heap_pos-1)/2);
                  END;
                  stud[heap_pos]:=element;
               END;

            for i:=n-1 DOWNTO 1 DO { place first element in its proper
                                      position , adjust the heap }
            BEGIN
               ivalue:=stud[i];  { find the larger node from a subtree
                                 delete it, and adjust the rest of tree }
               stud[i]:=stud[0];
               loc:=0;
               if(i=1) THEN
                    heap_pos:=-1
               else
                    heap_pos:=1;
                if ((i>2) AND (stud[2] > stud[1])) THEN
                          heap_pos:=2;
                while((heap_pos>=0)AND (ivalue<stud[heap_pos]))
                BEGIN
                   stud[loc]:=stud[heap_pos];
                   loc:=heap_pos;
                   heap_pos:=2*loc+1;
                   if((heap_pos+1<=i-1) AND (stud[heap_pos]<stud[heap_pos+1])) THEN
                         heap_pos:=heap_pos+1;
                   if(heap_pos>i-1) THEN
                        heap_pos:=-1;
                END;
                stud[loc]:=ivalue;
            END;
         END;
    {--------------End of function heapsort----------------------------}

        BEGIN {MAIN}
         REPEAT
         clrscr;
         WRITE(' Enter how many students ');
         READLN(n);
         if (n > MAX) THEN
              WRITELN(' Sorry... Array size is less')
         else
         BEGIN
           WRITELN('Enter The Records of',N,'students :');
           for i:=0 TO N-1 DO
           BEGIN
                WRITELN(' Enter the Roll Number ');
                READLN(stud[i]);
           END;
           clrscr;
           heapsort(stud,n);
           WRITELN('THE SORTED RECORDS ARE :');
            for i:=0 TO N-1 DO
              WRITELN('':10,stud[i]);
          WRITE('Do you wish to TRY again  ');
          READLN(ans);
         END;
         UNTIL((ans='n') OR(ans='N'));
        END.
{------------------------End of main-----------------------------------}