PROGRAM POLY_ADD;
TYPE
  PTR =^NODE;
  NODE = RECORD
        EXP,COEF:INTEGER;
        NEXT:PTR;
        END;

VAR
OPT:CHAR;
RESULT,SUM1,SUM2:PTR;
I:INTEGER;

PROCEDURE INSERT(COEF,EXP:INTEGER;VAR TAIL:PTR);
BEGIN
  NEW(TAIL^.NEXT);
  TAIL:=TAIL^.NEXT;
  TAIL^.COEF:=COEF;
  TAIL^.EXP:=EXP;
END;

PROCEDURE READPOLY(VAR RESULT:PTR);
VAR
OVER :BOOLEAN;
COEF,EXP,LEXP:INTEGER;
TAIL:PTR;

BEGIN
CLRSCR;
WRITELN(' ENTER EXPONENTS IN DECREASING ORDER ');
LEXP:=MAXINT;
NEW(RESULT);
REPEAT
   WRITELN;
   WRITELN('ENTER VALUES FOR ADDEND ');
   WRITE('COEFF ');
   READLN(COEF);
   WRITELN;
   OVER:=(COEF=0);
   IF NOT OVER THEN
   BEGIN
        WRITE('EXP ');
        READLN(EXP);
        IF(EXP>=LEXP) OR (EXP<0) THEN
        begin
           OVER :=TRUE;
           CLRSCR;
           if (EXP > LEXP) THEN
           begin
              WRITELN('SORRY');
           end
           else
               WRITE ('EXP LESS THAN 0');
           end
          else
            begin
            INSERT(COEF,EXP,TAIL);
            LEXP:=EXP;
            OVER:=(EXP=0);
            end;
        end;
        WRITE('TRY ');
        READLN(OPT);
        UNTIL(OPT='N');
        TAIL^.NEXT:=NIL;
        TAIL:=RESULT;
        RESULT:=RESULT^.NEXT;
        DISPOSE(TAIL);
      END;

PROCEDURE WRITEPOLY(VAR P:PTR);
BEGIN
 IF P=NIL THEN
 WRITELN('EMPTY')
 ELSE
  BEGIN
     WRITE(' ':25);
     WHILE (P<> NIL) DO
     BEGIN
       IF (P^.EXP=0) AND (P^.COEF=1) THEN
         WRITE(P^.COEF)
         ELSE
         IF (P^.EXP=0) THEN
         WRITE(P^.COEF:1)
         ELSE
         IF(P^.EXP=1) THEN
         WRITE(P^.COEF,'X')
         ELSE
         WRITE(P^.COEF,'X^',P^.EXP);
         P:=P^.NEXT;
         IF P<> NIL THEN
         BEGIN
          IF (P^.COEF < 0) THEN WRITE ( ' ')
          ELSE
           WRITE ('+');
           END;
         END;
         WRITELN;
         END;
   END;
PROCEDURE ADD(SUM1,SUM2:PTR;VAR RESULT:PTR);
VAR
P,Q,TAIL:PTR;
SUM:INTEGER;
BEGIN
P:=SUM1;
Q:=SUM2;
NEW(RESULT);
TAIL:=RESULT;
WHILE (P<>NIL) AND (Q<>NIL) DO
 IF (P^.EXP =Q^.EXP) THEN
 begin
     SUM:=P^.COEF+Q^.COEF;
     IF SUM <> 0 THEN
     INSERT(SUM,P^.EXP,TAIL);
     P:=P^.NEXT;
     Q:=Q^.NEXT;
 end
 ELSE
    IF P^.EXP > Q^.EXP THEN
    begin
       INSERT(P^.COEF,P^.EXP,TAIL);
       P:=P^.NEXT;
    end
    else
    begin
       INSERT(Q^.COEF,Q^.EXP,TAIL);
       Q:=Q^.NEXT;
    end;

WHILE (P<> NIL) DO
begin
       INSERT(P^.COEF,P^.EXP,TAIL);
       P:=P^.NEXT;
    end;

WHILE (Q<> NIL) DO
begin
       INSERT(Q^.COEF,Q^.EXP,TAIL);
       Q:=Q^.NEXT;
    end;

TAIL^.NEXT:=NIL;
P:=RESULT;
RESULT:=RESULT^.NEXT;
DISPOSE(P);
END;

BEGIN
CLRSCR;
I:=1;
READPOLY(SUM1);
I:=I+1;
READPOLY(SUM2);
ADD(SUM1,SUM2,RESULT);
CLRSCR;
WRITEPOLY(SUM1);
WRITEPOLY(SUM2);
WRITEPOLY(RESULT);
END.


