{  PROGRAM TO IMPLEMENT QUICK SORT ALGORITHM }

PROGRAM Q_SORT;

CONST
    MAX = 25; {MAXIMUM LIST SIZE}

TYPE
   ITEM=STRING[6];
   INDEX=1..MAX;
   LIST=RECORD
        COUNT:INDEX;
        ENTRY:ARRAY[INDEX] OF ITEM;
       END;
VAR
   L:LIST;
   NAM :STRING[6];
   I,NENTRY:INTEGER;
   OPT:CHAR;
{-------------------end of declarations-----------------------------}

PROCEDURE SWAP(X,Y:INDEX;VAR L:LIST);
{PROCEDURE TO SWAP THE NAMES AT X AND Y FROM THE LIST L}

VAR
  T:ITEM;
  BEGIN
       WITH L DO
       BEGIN
            T:=ENTRY[X];
            ENTRY[X]:=ENTRY[Y];
            ENTRY[Y]:=T;
      END;
END;
{-----------------end of procedure SWAP--------------------------}

PROCEDURE PARTITION(VAR  L:LIST;LOW,HIGH:INDEX;VAR PIVOTLOC:INDEX);
{Procedure to partition the list into sublists. One starting from
low to pivotloc-1, adn the other from pivotloc+1 to high}

VAR
    PIVOT:ITEM;
    I,LASTSMALL:INDEX;
BEGIN
     SWAP(LOW,(LOW+HIGH) DIV 2,L);
     PIVOT:=L.ENTRY[LOW];
     LASTSMALL:=LOW;
     FOR I:=LOW+1 TO HIGH DO
     IF L.ENTRY[I] < PIVOT THEN
     BEGIN
        LASTSMALL:=LASTSMALL+1;
        SWAP(LASTSMALL,I,L);
     END;
   SWAP(LOW,LASTSMALL,L);
   PIVOTLOC:=LASTSMALL;
END;
{-------------------end of procedure PARTITION---------------------}

PROCEDURE SORT(VAR L:LIST;LOW,HIGH:INTEGER);
{ A recursive procedure to sort the list}
VAR
PIVOTLOC:INDEX;
BEGIN
     IF  LOW < HIGH THEN
     BEGIN
        PARTITION(L,LOW,HIGH,PIVOTLOC);  {partition the list}
        SORT(L,LOW,PIVOTLOC);            {sort the lower half}
        SORT(L,PIVOTLOC+1,HIGH);         {sort the upper half}
    END;
END;
{--------------------end of procedure SORT-----------------------}

BEGIN  {MAIN}
CLRSCR;
       WRITE('':10,' ENTER HOW MANY NAMES : ');
       READLN(NENTRY);
       FOR I:=1 TO NENTRY DO
       BEGIN
           WRITE('':10,'ENTER NAME ',I,'  ');
           WITH L DO
           BEGIN
             READLN(NAM);
             COUNT:=I;
             ENTRY[I]:=NAM;
          END;
     END;
  SORT(L,1,L.COUNT);
  WRITELN;WRITELN;
  WRITELN('':10,'SORTED LIST OF NAMES IS :');
  FOR I:=1 TO L.COUNT DO
  BEGIN
    WITH L DO
        WRITELN('':15,ENTRY[I])
 END;
END.
{---------------------END OF MAIN------------------------------------}