       {PROGRAM TO ADD THE SPARSE MATRICES.
       The program reads the sparse matrices as described in the text.
       The addition is carried out as it is done in ordinary matrices.}

    PROGRAM SP_ADD;
    CONST MAX=10;      {maximum value of rw/column}

    TYPE
       TRIO =RECORD    {define the record to hold row,column and
                        non zero value. A flag is used to denote whether
                        that element is considered or not }

            NR,NC,VAL:INTEGER;
            FLAG:INTEGER;
            END;

    VAR
        M1,N1,M2,N2         :INTEGER;   {row and column size of two matrices}
        K,T,KK,NT,I,T1,T2,J :INTEGER;
        A,B,C               :ARRAY[1..MAX] OF TRIO;

{-------------------end of declarations------------------------------------}

    BEGIN  {main}

        CLRSCR;

        WRITE('':10,'ENTER THE ORDER OF FIRST MATRIX  : ');
        READLN(M1,N1);
        writeln;
        WRITE('':10,'ENTER THE OREDR OF SECOND MATRIX : ');
        READLN(M2,N2);
        writeln;
        WRITE('HOW MANY NON ZERO ELEMENTS IN FIRST MATRIX :');
        READLN(K);
        writeln;
        writeln;
        FOR I:=1 TO K DO
        BEGIN
           WRITE('':5,'ENTER Row,Column,Value for first matrix :');
           READLN(A[I].NR,A[I].NC,A[I].VAL);
           A[I].FLAG:=0;
        END;

        WRITE('HOW MANY NON ZERO ELEMENTS IN SECOND MATRIX : ');
        READLN(KK);
        writeln;
        writeln;
        FOR I:=1 TO KK DO
        BEGIN
            WRITE('':5,'ENTER Row,Column,Value ');
            READLN(B[I].NR,B[I].NC,B[I].VAL);
            B[I].FLAG:=0;
        END;
        IF (K>KK) THEN    {store larger number of nonzero elements}
        BEGIN             {in T1 }
            T1:=K;
            T2:=KK;
        END
        ELSE
        BEGIN
            T1:=KK;
            T2:=K;
        END;
        NT:=0;
        FOR I:=1 TO T2 DO
        BEGIN
          FOR J:=1 TO T1 DO
           BEGIN
             IF((A[I].NR=B[J].NR) AND
                  (A[I].NC=B[J].NC)AND (A[I].FLAG=0) AND (B[J].FLAG=0)) THEN
             BEGIN     {add values of both matrices where indices are same}
                 NT:=NT+1;
                 C[NT].NR:=A[I].NR;
                 C[NT].NC:=A[I].NC;
                 C[NT].VAL:=A[I].VAL+B[I].VAL;
                 A[I].FLAG:=1;
                 B[I].FLAG:=1;
            END;
           END;
        END;
        FOR I:=1 TO K DO  {copy remaining elements of first matrix}
        IF (A[I].FLAG <>1) THEN
        BEGIN
           NT:=NT+1;
           C[NT].NR:=A[I].NR;
           C[NT].NC:=A[I].NC;
           C[NT].VAL:=A[I].VAL;
        END;
        FOR I:=1 TO KK DO   {copy remaining elements of second matrix}
          IF (B[I].FLAG <>1) THEN
          BEGIN
              NT:=NT+1;
              C[NT].NR:=B[I].NR;
              C[NT].NC:=B[I].NC;
              C[NT].VAL:=B[I].VAL;
          END;
          writeln;
          writeln;
       WRITELN('':10,'THE RESULTING MATRIX IS :');
       WRITELN('':5,'ROW    COLUMN      VALUE');
       FOR I:=1 TO NT DO
       WRITELN('':5,C[I].NR,'':8,C[I].NC,' ':10,C[I].VAL);
END.



{-------------------end of main----------------------------------------}