{ PROGRAM TO IMPLEMENT stack using arrays. }

    PROGRAM STACK;
    CONST MAX =20;   {maximum array size}

    TYPE STACK = RECORD
                 TOP:0..MAX;
                 INFO:ARRAY[1..MAX] OF INTEGER;
                 END;

    VAR
       N,Y,OPT,K:INTEGER;
       S1       :STACK;
{--------------end of declaration part-------------------------------}

    PROCEDURE PUSH(X:INTEGER;N:INTEGER;VAR S:STACK);
    {procedure to push an element into stack}

     BEGIN
        WITH S DO
        BEGIN
           TOP:=TOP+1;
           INFO[TOP]:=X;
        END;
     END;
{-----------end of procedure PUSH------------------------------------}

    PROCEDURE POP(VAR S:STACK);
    {procedure to pop an element from the stack}
    VAR
       X:INTEGER;
    BEGIN
        WITH S DO
        begin
          X:=INFO[TOP];
          writeln('item popped is ',x);
          TOP:=TOP-1;
        end;
    END;

{-----------end of procedure POP------------------------------------}

    FUNCTION EMPTY(VAR S:STACK):BOOLEAN;
    {Function to check whether the stack is empty}
    BEGIN
       EMPTY:=(S.TOP=0);
    END;


{-----------end of procedure EMPTY------------------------------------}

    FUNCTION FULL(VAR S:STACK):BOOLEAN;
    {Function to check whether the stack is full}
    BEGIN
       FULL:=(S.TOP=N);
    END;

{-----------end of procedure EMPTY------------------------------------}

    PROCEDURE INITIALISE(VAR S:STACK);
    {procedure to initialise the stack}
    BEGIN
       S.TOP:=0;
    END;
{-----------end of procedure INITIALISE-------------------------------}
    BEGIN {MAIN}

        INITIALISE(S1);
        WRITE('        ENTER THE STACK SIZE ');
        READLN(N);
        IF (N>MAX) THEN
            WRITE('......SORRY! You have exceeded the maximum limit ')
        ELSE
        BEGIN
           REPEAT
             writeln('                MENU');
             WRITELN('                ----');
             WRITELN('                1 PUSH ');
             WRITELN('                2 POP ');
             WRITELN('                3 PRINT');
             WRITELN('                4 EXIT');
             WRITELN('.....................................');
             WRITE('       Enter your Choice : ');
             READLN(OPT);
             CASE OPT OF
                       1: BEGIN
                            WRITELN('Enter a number to pushed');
                            READLN(Y);
                            IF (FULL(S1)) THEN
                                WRITELN('STACK IS FULL')
                            ELSE
                                PUSH(Y,N,S1);
                           END;

                       2: IF (EMPTY(S1)) then
                             writeln('stack is empty')
                          ELSE
                             POP(S1);

                       3: BEGIN
                              K:=S1.TOP;
                              IF (EMPTY(S1)) THEN
                                 writeln('sorry stack is empty')
                              ELSE
                                begin
                                  writeln('   STACK IS ');
                                  REPEAT
                                     WRITELN(s1.INFO[k]);
                                     K:=K-1;
                                  UNTIL (k=0);
                                 end;
                           END;
             END;

           UNTIL(OPT =4);

          END;
      END.

{-----------------------END OF MAIN----------------------------------}