{ Program to implement stack using linked list.
  While creating the stack, the new element always gets added to the
  front and the same is the case while deleting}

PROGRAM LINK_LST;

{Program to implement stack using  linked list }
TYPE
     PTR =^NODE;
     NODE=RECORD
          INFO :INTEGER;
          NEXT :PTR;
          END;

VAR
   TOP  :PTR;
   X,ANS:INTEGER;
{--------------------end of declarations-----------------------------}

FUNCTION EMPTY:BOOLEAN;
BEGIN
    EMPTY :=(TOP=NIL);
END;
{------------function to check empty condition-----------------------}

PROCEDURE PUSH(X:INTEGER);
{procedure to push the new element onto stack}

VAR P,Q:PTR;
BEGIN
    NEW(P);
    P^.INFO:=X;
    P^.NEXT:=NIL;
    IF(TOP = NIL) THEN
     TOP :=P
     ELSE
     BEGIN
         P^.NEXT:=TOP;
         TOP:=P;
    END;
END;
{-----------------end of procedure PUSH-----------------------------}

PROCEDURE POP;
{procedure to takeout the element from the stack}
VAR
  Q,R:PTR;
  BEGIN
      Q:=TOP;
      IF (EMPTY) THEN
      WRITELN('':10,'STACK  IS EMPTY')
      ELSE
      BEGIN
           WRITELN('':10,Q^.INFO:2,'  IS POPPED OUT');
            TOP:=TOP^.NEXT;
           Q^.NEXT:=NIL;
           DISPOSE(Q);
          end;
 END;
{-----------------end of procedure POP--------------------------------}

PROCEDURE DISPLAY;
{Procedure to display the stack contents}
VAR
   Q:PTR;
BEGIN
    IF (TOP=NIL) THEN
     WRITELN('':10,'STACK IS EMPTY')
    ELSE
    BEGIN
     WRITELN;WRITELN;
     WRITELN('Stack is : ');
    Q:=TOP;
    WHILE (Q <> NIL) DO
    BEGIN
      WRITELN('':10,Q^.INFO);
      Q:=Q^.NEXT;
    END;
    END;
    WRITELN;WRITELN;
END;
{--------------------end of procedure DISPLAY--------------------------}

BEGIN     {MAIN}
     clrscr;
    TOP:=NIL;
    ANS:=1;
    WHILE(ANS <> 4) DO
    BEGIN
        WRITELN('':10,'1. PUSH');
        WRITELN('':10,'2. POP');
        WRITELN('':10,'3. DISPLAY');
        WRITELN('':10,'4. EXIT');
        WRITELN;
        WRITELN;
        WRITE('':10,'ENTER OPTION');
        READLN(ANS);
        CASE ANS OF
          1:Begin
                WRITE('':10,'ENTER NUMBER TO PUSH  ');
                READLN(X);
                PUSH(X);
            End;
          2:
             POP;
          3:DISPLAY;
        END;
     END;
 END.
 {------------------------END OF MAIN-------------------------------------}


